// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial purpose use without permit.                        *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************

#ifndef __AZERROR_H__
#define __AZERROR_H__

class AZError
{
  AZErrorClass errClass; //  8 bit
  AZErrorCode  errCode;  // 24 bit
  
  long Long() const { return (errCode?errClass<<24:0)|errCode; }

public:
  AZError     (AZErrorClass errClass);
  void SetError(AZErrorCode _errCode) { errCode=_errCode; }
  long Error() const                  { return Long(); }
  operator long() const               { return Long(); }
};

// jetzt das ganze mit einem fehlertext
class AZStrError: public AZError
{
  AZString     errorStr;
public:
  AZStrError   (AZErrorClass errClass):AZError(errClass) {}
  void SetError(AZErrorCode _errCode,const char *_str) 
    { AZError::SetError(_errCode); errorStr=_str; }
  const char *Text() const { return errorStr.Text(); }  
}; 

#endif


