// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial purpose use without permit.                        *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************

#ifndef __AZSTRING_H__
#define __AZSTRING_H__

class AZString
{
  int len;
  char *txt;
public:
  AZString()  { len=0; txt=new char[1]; *txt=0; }
  AZString(const char *,int len=0);
  AZString(const AZString &);
  ~AZString();

  AZString & operator= (const AZString &);
  int        operator!=(const AZString &) const;
  int        operator==(const AZString &) const;
  int        operator!=(const char *) const;
  int        operator==(const char *) const;
  AZString & operator+=(const char *);
  AZString & operator+=(char);
  AZString & operator+=(const AZString &);
  operator const char *() const { return txt; }
  AZString operator +(const char *) const;

  int Len() const { return len; }
  const char * Text() const { return txt; }
};

typedef struct WChar
{
  char array[2];
  int operator ==(WChar i) { return memcmp(array,i.array,sizeof(WChar))==0; }
} _wchar;

class AZWString
{
  int   len;
  // nicht null terminiert!!!
  WChar *txt;
public:
  ~AZWString() { delete [] txt; }
  AZWString():len(0),txt(0) {}
  AZWString(const WChar &,int len);
  AZWString(const AZWString &);
  AZWString & operator=(const AZWString &);
  AZWString & operator+=(const WChar &);
  
  const WChar * Text() const { return txt; }
  // liefert die Laenge in WChar, nicht in BYTES!
  int Len() const { return len; }

/*  
  AZWString(const AZString &);
  AZString & operator= (const AZString &);

  int        operator!=(const AZString &) const;
  int        operator==(const AZString &) const;
  int        operator!=(const char *) const;
  int        operator==(const char *) const;
  AZString & operator+=(const char *);
  AZString & operator+=(char);
  AZString & operator+=(const AZString &);
  operator const char *() const { return txt; }
  AZString operator +(const char *) const;

  int Len() const { return len; }
  const char * Text() const { return txt; }
*/
};

#endif

