// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial purpose use without permit.                        *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************

#ifndef __CLASSLIB_H__
#define __CLASSLIB_H__

#define BASELIBVER     "1.13";
#define BASELIBMAJORVER 1
#define BASELIBMINORVER 13

// exportierte funktionen
extern const char *GetBaseLibVer();
extern int         GetBaseLibMajorVer();
extern int         GetBaseLibMinorVer();

// exportierte variablen
// niemand nutzt die, warum dann exportieren
//extern int         global_debug_level;
//extern bool        global_quiet;

#if defined(lnx)
  #define INT3 __asm__ ("int3");
#else
  #define INT3;
#endif

// #if !defined(__DOS16__) && !defined(__WIN32__)
#if defined(__WATCOM__) || defined(__LINUX__) || (defined(__VCPP__) && !defined(_INC_WINDOWS))
template <class T> const T& min(const T &a,const T&b)
{
  if (a>b)
    return b;
  return a;
}

template <class T> const T& max(const T &a,const T&b)
{
  if (a<b)
    return b;
  return a;
}
#endif

// #define THREAD_CREATE(X,Y) if (!fork()) X(Y)

const char * getprofilestring(const char *fname,
                              const char *key,
                              char *ret,unsigned int len);

const unsigned int KEYWORDLEN = 8192;
const long SUCCESS=0;

typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;
typedef double         qword;

#define SWAP_WORD(x)   ( (((byte)(x))<<8) | (((x)>>8)&0xff) )
#define SWAP_DWORD(x)  ( (SWAP_WORD(x) << 16) | \
                         (SWAP_WORD(   (word) ((x)>>16) ) ))
#ifdef MSB_FIRST
#define SWAP_WORD_X(x)  ((x)= SWAP_WORD(x))
#define SWAP_DWORD_X(x) ((x)= SWAP_DWORD(x))
#define SWAP_QWORD_X(x) { byte *p=(byte *)&x; for (int i=0; i<4; i++) { byte c=p[i];p[i]=p[7-i];p[7-i]=c; }}
#else
#define SWAP_WORD_X(x)
#define SWAP_DWORD_X(x)
#define SWAP_QWORD_X(x)
#endif

#endif

/**************************************************************************
$Log: classlib.h,v $
Revision 1.6  2004/07/03 08:06:37  hobbes
copy to new project structure, increment lib-version

Revision 1.5  2000/07/06 08:06:37  hobbes
alle klassen in extra include files ausgelagert

Revision 1.4  2000/07/05 10:47:38  hobbes
versionStr dem Kontruktor von AZArguments hinzugefgt
alle Optionen (debug, version ...) aus AZArguments sind private
dafuer gibts: global_debug_level und global_quiet
AZIntArgument hinzugekommen

Revision 1.3  2000/07/05 08:20:27  hobbes
V1.04 gesetzt; ProcessArguments

Revision 1.2  2000/04/19 06:18:31  hobbes
log hinzugefuegt

**************************************************************************/

