// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial purpose use without permit.                        *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************

#ifndef __XPRINTF_H__
#define __XPRINTF_H__

typedef enum INFO_LEVEL
{
  INFO_ERROR     = 0, // FEHLER werden immer ausgegeben!!!
  INFO_DEBUG     , // debugLebel=0 "t ..."
  INFO_WARN      , // debugLevel=1 jetzt mit warnings "w ..."
  INFO_ERROR_TXT , // debugLevel=2 mehr text zum Fehler "t ..."
  INFO_WARN_TXT  , // debugLevel=3 mehr text zur Warnung "t ..."
  INFO_TXT       , // sonstige Bemerkungen "t ..."
  INFO_MAX         // niedrigste Stufe; unwichtige Bemerkungen "t ..."
} _INFO_LEVEL;

// steuert die Ausgabe
extern void XPrintf(INFO_LEVEL level,const char *fmt,...);

extern bool       __quiet;
extern INFO_LEVEL __infoLevel;
// diese meldung kann mit der -quiet option abgeschalten werden

#ifdef __NOVARARGS__

void Printf(const char *a,...);
void PrintfDiv(const char *a,...);
void PrintfTxt(const char *a,...);
void PrintfWarnTxt(const char *a,...);
void PrintfErrTxt(const char *a,...);
void PrintfWarn(const char *a,...);
void PrintfDebug(const char *a,...);
void PrintfErr(const char *a,...);

#else

#define Printf(fmt,a...) if (!__quiet) printf(fmt,##a)

// frueher stand hier ... compilerabhaengig oder fehler ??
// #define Printf(fmt,a##) if (!__quiet) printf(fmt,##a)
// diese meldungen werden vom debug level beeinflusst
// und koennen nicht mit -quiet abgeschalten werden
// und werden im ggs Printf auf stderr ausgegeben
// und erhalten noch einen vorangestellten text "e " "w " oder "t " s.o.

#define PrintfDiv(format,a...)     XPrintf(INFO_MAX      ,format, ##a)
#define PrintfTxt(format,a...)     XPrintf(INFO_TXT      ,format, ##a)
#define PrintfWarnTxt(format,a...) XPrintf(INFO_WARN_TXT ,format, ##a)
#define PrintfErrTxt(format,a...)  XPrintf(INFO_ERROR_TXT,format, ##a)
#define PrintfWarn(format,a...)    XPrintf(INFO_WARN     ,format, ##a)
#define PrintfDebug(format,a...)    XPrintf(INFO_DEBUG   ,format, ##a)
#define PrintfErr(format,a...)     XPrintf(INFO_ERROR    ,format, ##a)

#endif // __NOVARARGS__

#endif

/*************************************************************************
$Log: xprintf.h,v $
Revision 1.5  2000/07/09 14:54:00  hobbes
fertig


*************************************************************************/