; *********************************************************************
; *                                                                   *
; * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
; *                                                                   *
; * These files are for reference only. You may not use these files   *
; * for commercial use without permit.                                *
; *                                                                   *
; * b@loet.de                                                         *
; *                                                                   *
; * 1.00 2004-07-04                                                   *
; *      first released                                               *
; *                                                                   *
; *********************************************************************

BITS 16
USE_HALFCHAR EQU 1
; default ist testmode
; alles andere wird spaeter per programm geaendert
_TEST_       EQU 1

; watcom und bcc
GLOBAL main_boot_
GLOBAL _main_boot
GLOBAL _par_entry_size
GLOBAL _par_partition_entry_len
GLOBAL _par_partition_entry_count
GLOBAL _par_partition_starts_offset
GLOBAL _par_test_mode
GLOBAL _par_wartezeit
GLOBAL _par_startverzoegerung
GLOBAL _par_config
GLOBAL _par_byte_len
GLOBAL _par_hide_offset
GLOBAL _par_cols
GLOBAL _version_str
GLOBAL _register_name
GLOBAL _register_text

GLOBAL _hide
GLOBAL _entries


MAXENTRIE EQU 10
WINTOP    EQU 6 ; Zeilen
WINBOTTOM EQU 5 ; Zeilen
WINHEIGHT EQU (MAXENTRIE+WINTOP+WINBOTTOM)
WINWIDTH  EQU 49
WINX      EQU ((80-(WINWIDTH))/2)
WINY      EQU ((25-(WINHEIGHT))/2)
ENTRW     EQU 32
PASSWDLEN EQU 8
HIDINGLEN EQU 10
FIRSTENT  EQU (WINY+WINTOP)
TIMEOUT   EQU 25 ; 25 sekunden timeout - 0x8000: kein Limit

; color defs
%define MOV_BL_COL_NORMAL     mov bl,[_par_cols]
%define MOV_BL_COL_IMPORTANT  mov bl,[_par_cols+1]
%define MOV_BL_COL_MENU       mov bl,[_par_cols+2]
%define MOV_BL_COL_SEL        mov bl,[_par_cols+3]

;  macro
;          mov bl,[_par_cols]
; #em
;MOV_BL_COL_IMPORTANT  macro
;          mov bl,[_par_cols+1]
;#em
;MOV_BL_COL_MENU  macro
;          mov bl,[_par_cols+2]
;#em
;MOV_BL_COL_SEL   macro
;          mov bl,[_par_cols+3]
;#em


; par_config db 0
CFG_BEEP_BEIMSTART   EQU 1
CFG_NO_WRITE         EQU 2

; defines fuer flagfield PartitionEntry
; wenn diese partition gewaehlt wurde, setzte active-flag des mbr
FLAG_SET_ACTIVE_FLAG      EQU 1
; trage in das byte 36 des bootsektors die hdnr ein
; nur fuer fat-lw
FLAG_SET_BYTE36_TO_HDNR   EQU 2
; drdos macht es anders fuer dos6.0 wird 1fd genutzt
FLAG_SET_BYTE1FD_TO_HDNR  EQU 4
; os2 bootmanager
FLAG_SET_BYTE53_TO_HDNR   EQU 8


struc PartitionTableEntry
active:     resb 1
start_head: resb 1
start_zyl:  resw 1
part_id:    resb 1
end_head:   resb 1
end_zyl:    resw 1
rel_start:  resd 1
sec_count:  resd 1
endstruc

struc PartitionEntry
isEntry     resb 1
entryname   resb ENTRW 
addinfos    resb WINWIDTH-4-ENTRW 
disk        resb 1
lower8cyl   resb 1
sek05cyl67  resb 1
head        resb 1
parameter   resb 1 ; dieser parameter wird dem bios uebergeben 40h:0f0h
lba_adresse resd 1
hiding_map  resb HIDINGLEN
password    resb PASSWDLEN
flagfield   resb 1
PARTSIZE    EQU $-isEntry
;PARTSIZE    equ sizeof PartitionEntry
endstruc

struc LBALoad     
len         resb 1
reserved    resb 1
count       resw 1
buf_off     resw 1
buf_seg     resw 1
lba_low     resd 1
lba_high    resd 1
endstruc

struc CHSLoad     
s_hdnr        resb 1
s_head        resb 1
s_zylsec      resw 1
s_lba_adresse resd 1
endsendstruc

struc HidingEntry 

  h_dosName:            resb 1
  h_index_in_table:     resb 1
  h_hdnr:               resb 1
  h_head:               resb 1
  h_start_zyl:          resw 1
  h_lbaadr:             resd 1
  h_line:               resb 16 

  HIDSIZE               EQU $-h_dosName

endstruc


        segment private code class=CODE align=4096

main_boot_:
_main_boot:
        jmp start_boot

; ***********************
;
; exportierte parameter
;
; ***********************

parameter_block_starts:
        ; laenge aller eintraege
_par_entry_size:
        dw parameter_block_ends-parameter_block_starts
_par_partition_entry_len:
        dw PARTSIZE
_par_partition_entry_count:
        dw MAXENTRIE
_par_partition_starts_offset:
        dw _entries
_par_test_mode:
        db _TEST_
_par_config:
        db 0
_par_startverzoegerung:
        dw 0
_par_byte_len:
        dw _main_boot_ends-main_boot_
_par_cols:
        db 1fh ;COL_NORMAL
        db 1eh ;COL_IMPORTANT blau/yellow
        db 1fh ;COL_MENU
        db 3eh ;COL_SEL
_par_wartezeit:
        dw TIMEOUT

parameter_block_ends:

menu_top:
        db ""
        db "                                               "
        db " Mr. Boot V"
_version_str:
                    db "4.20d  (C)2000 http://www.mrboot.de "
        db " "
_register_text:
        db "         (nicht "
       ;db "lizensiert fr: "
_register_name:
        db "lizenzierte Version)          "
       ;db "Wolfram Abeer                "
        db "                                               "
        db "  "
menu_line:
        db "                                               "
menu_bottom:
        db "  "
        db "                                               "
        db "  "
        db " -auswhlen  ENTER-booten                    "
        db ""
leerzeile:
        db "                                                 "
timer_msg:
        db " Verbleibende Zeit:"
timer_msg1:
        db "     "
timer_msg2:
        db "Sekunden               "
timer_msg3:
hex2dez:
        db "0123456789 "
_entries:
        times PARTSIZE*10 db 0 ; 10 mal PartitionEntries
mbradr:
        db 80h,0,1,0,0,0,0,0
selected_entry:
        db FIRSTENT ; immer den ersten eintrag markieren=default
;PRINTC

;*****************************************************************
;
; TIMER_START:
; testet, ob das schon passiert ist und
; setzt den interrupt vektor-8 auf eine routine
;
; ax timeout
; bx near call zur routine die jede sekunde aufgerufen werden soll
;
;*****************************************************************
timer_start:
        push    ax
        push    es

        cmp     ax,0ffffh
        jz      timer_start_ret ; wenn zeit ==  -1 timer gar nicht erst starten

        mov     ax,[ds:old_timer_seg]
        or      ax,[ds:old_timer_off]
        jnz     timer_start_ret

        mov     ax,0
        mov     es,ax
        cli
        mov     ax,[es:8*4]
        ;mov     ds:[old_timer_off],ax
         
        mov     [ds:old_timer_off],ax
        mov     ax,[es:8*4+2]
        mov     [ds:old_timer_seg],ax

        mov     ax,timer_proc
        mov     [es:8*4],ax
        mov     ax,cs
        mov     [es:8*4+2],ax

        mov     [timer_value],word 0
        mov     [on_timer_call],bx
        sti

timer_start_ret:
        pop     es
        pop     ax
        ret
;timer_start        endp

;*****************************************************************
;
; TIMER_STOP:
; setzt den interrupt vektor-8 auf den alten wert
;
;*****************************************************************
timer_STOP

        mov     ax,[ds:old_timer_seg]
        or      ax,[ds:old_timer_off]
        jz      timer_stop_ret

        push    ax
        push    bx
        push    si
        push    es

        cli
        mov     ax,0
        mov     es,ax

        mov     si,old_timer_off
        mov     bx,[si]
        mov     [si],ax
        mov     [es:8*4],bx

        mov     si,old_timer_seg
        mov     bx,[si]
        mov     [si],ax
        mov     [es:8*4+2],bx

;        mov     wordcs:[timer_value],0ffffh
        mov     [cs:timer_value],word 0ffffh
        mov     bx,on_timer_call
        call    [cs:bx]
;       call    cs:[on_timer_call] ; near call ; ein letztes mal

        sti

        pop     es
        pop     si
        pop     bx
        pop     ax
timer_stop_ret:
default_timer_proc:
        ret
;timer_STOP        endp

;*****************************************************************
;
; TIMER_PROC:
; zaehlt alle 55ms und gibt jede sekunde die verbleibende zeit aus
;
;*****************************************************************
timer_proc:
        pushf
        push bx
        mov     bx,old_timer_off
        call    far [cs:bx]
        pop  bx
;        call far cs:[old_timer_off]

        cli
        push    ax
        push    cx
        push    dx
        push    es

; debug, ob der timer noch laeuft oder schon abgestuerzt ist
;        mov     ax,0b800h
;        mov     es,ax
;        mov     al,cs:[timer_value]
;        mov     es:[0],al

        mov     ax,[cs:timer_value]
        mov     cx,55
        mul     cx
        mov     cx,1000
        div     cx

        ; rest ist in dx
        cmp     dx,55
        jnb     no_timer_call

        mov     bx,on_timer_call
        call    [cs:bx] ; near call
;        call    cs:[on_timer_call] ; near call

no_timer_call:
        mov     bx,timer_value
        inc     word [cs:bx]
;        inc     wordcs:[timer_value]
        pop     es
        pop     dx
        pop     cx
        pop     ax
        sti

        iret

; timer_proc       endp

;*****************************************************************
;
; TIMER_REACHED:
; ob der timeout bereits ueberschritten ist
;
; ZF timeout
;
;*****************************************************************
timer_reached:
        push    ax
        push    bx
        push    cx
        push    dx

        mov     ax,[timer_value]
        mov     cx,55
        mul     cx
        mov     cx,1000
        div     cx
        ; in AX sekunden seit start
        mov     bx,[_par_wartezeit]
        sub     bx,ax

        pop     dx
        pop     cx
        pop     bx
        pop     ax
        ret
;timer_reached       endp

;*****************************************************************
;
; CLRSCR:
;
;*****************************************************************

BOOTMGR_clrscr:

        push ax
        push bx
        push cx
        push dx

        mov  ax,0500h  ; set active page 0
        int  10h
        mov  ax,0600h  ; scroll window(6) 0 Zeilen==ganzes Fenster;
        mov  bh,07h    ; setzte graue Schrift auf schwarzem Grund
        xor  cx,cx     ; links oben:   zeile  0, spalte 0
        mov  dx,184fh
        int  10h

        pop dx
        pop cx
        pop bx
        pop ax
        ret
;clrscr  endp

;*****************************************************************
;
; WINDOW
;
;*****************************************************************

window 
        mov     bp,menu_top
        mov     dh,WINY
        mov     dl,WINX
        mov     cx,WINWIDTH
        mov     bh,00
        ; weisse schrift auf blauem grund
        MOV_BL_COL_NORMAL

winm2:  mov     ax,1300h   ; write stringxy
        int     10h
        inc     dh
        add     bp,cx
        cmp     dh,WINY+WINTOP
        jb      winm2
        mov     bp,menu_line
m1:     mov     ax,1300h
        int     10h
        inc     dh
        cmp     dh,WINY+WINHEIGHT-WINBOTTOM
        jb      m1

        mov     bp,menu_bottom
winm3:  mov     ax,1300h   ; write stringxy
        int     10h
        inc     dh
        add     bp,cx
        cmp     dh,WINY+WINHEIGHT
        jb      winm3

        mov     dh,WINY+WINHEIGHT-2
        mov     dl,WINX+2
        mov     cx,2
        mov     bp,menu_bottom+3*WINWIDTH+2 ; zeichen soll gelb werden
        mov     bh,00
        MOV_BL_COL_IMPORTANT
        mov     ax,1300h
        int     10h
        mov     dl,WINX+2+14
        mov     bp,menu_bottom+3*WINWIDTH+2+14
        mov     cx,5
        mov     ax,1300h
        int     10h
        ;cmp     word[time_left],08000h ; timer stop
        ;jnz     win_m1
        ;call    remove_counter_text
win_m1:
        ret
;window  endp

;*****************************************************************
;
; PRINTTIME
;
;*****************************************************************

printtime
        push    ax
        push    bx
        push    cx
        push    dx
        push    bp
        push    ds
        push    es

        push    cs
        push    cs
        pop     ds
        pop     es

        mov     ax,[timer_value]
        cmp     ax,0ffffh
        jz      remove_counter  ; wir kommen gerade von einem timer_stop

        mov     cx,55
        mul     cx
        mov     cx,1000
        div     cx
        ; in AX sekunden seit start
        mov     bx,[_par_wartezeit]
        sub     bx,ax
        push    bx

        cmp     bx,0
        jnz     print_time_next
        pop     bx
        ; remove counter
        call    timer_STOP
remove_counter:
        mov     bp,menu_line
        mov     dh,WINY+WINHEIGHT-4
        mov     dl,WINX
        mov     cx,WINWIDTH
        mov     bh,00
        MOV_BL_COL_NORMAL
        mov     ax,1300h
        int     10h
        jmp     print_time_end

print_time_next:
        mov     bp,timer_msg
        mov     dh,WINY+WINHEIGHT-4
        mov     dl,WINX
        mov     cx,timer_msg1-timer_msg
        mov     bh,00
        MOV_BL_COL_NORMAL
        mov     ax,1300h
        int     10h

        ; plus anzahl der zeichen dazwischen
        mov     dl,WINX+timer_msg2-timer_msg
        mov     bp,timer_msg2
        mov     cx,timer_msg3-timer_msg2
        mov     bh,00
        MOV_BL_COL_NORMAL
        mov     ax,1300h
        int     10h

        pop     bx      ; anzahl der sekunden seit dem start

m11:
        mov     dh,WINY+WINHEIGHT-4
        mov     dl,WINX+23
        mov     ax,bx ; ax := time_left
        cmp     ax,0
        jz      m16

m13:
        push    dx
        mov     dx,0
        mov     bx,10
        div     bx
        mov     bx,dx
        pop     dx
        ; so unsere erste stelle ist berechnet
        push    ax
        mov     bp,hex2dez
        add     bp,bx
        mov     cx,1

        mov     bh,00
        MOV_BL_COL_NORMAL
        mov     ax,1300h
        int     10h
        dec     dl
        pop     ax
        cmp     al,0
        jnz     m13
        mov     bp,hex2dez+10 ; leerzeichen
        mov     ax,1300h   ; und noch ein leerzeichen dran
        mov     bh,00
        MOV_BL_COL_NORMAL  ; damit man auch von 10 auf 9 kommt
        mov     cx,1
        int     10h
m14:    mov     al,1 ; ret=1 = time limit noch nicht erreicht
m16:
print_time_end:
        pop     es
        pop     ds
        pop     bp
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        ret
        ;printtime endp

;*****************************************************************
;
; test_for_1024 adresse: [si] hat jetzt adresse des sektors
;                           adressaufbau: hdnr(1)head(1)zyl(2)lba(4)
;
; ret: ZF <= 1024
; wir schauen uns die lba adresse an und testen
; ob lbaadresse/#head/#sector >=1024 ist
;*****************************************************************
test_for_1024:
;:
        push    ax
        push    bx
        push    cx
        push    dx
        push    di
        push    es


;Return: CF set on error
;	    AH = status (07h) (see #00234)
;	CF clear if successful
;	    AH = 00h
;	    AL = 00h on at least some BIOSes
;	    BL = drive type (AT/PS2 floppies only) (see #00242)
;	    CH = low eight bits of maximum cylinder number
;	    CL = maximum sector number (bits 5-0)
;      		 high two bits of maximum cylinder number (bits 7-6)
;	    DH = maximum head number
;	    DL = number of drives
;	    ES:DI -> drive parameter table (floppies only)

        mov     ah,8
        mov     dl,[si+s_hdnr]
        int     13h
        ; cl sector
        and     cl,3fh ; bit 6&7 sind fuer die zylinder
        ; dh heads
        inc     dh

        mov     al,dh
        mul     cl
        ; in ax
        mov     cx,ax

        mov     ax,word [si+s_lba_adresse]
        mov     dx,word [si+s_lba_adresse+2]
        div     cx
        ; jetzt noch durch 1024 teilen
        mov     cl,10
        shr     ax,cl
        ; ZF <1024
        pop     es
        pop     di
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        ret
;test_for_1024 endp
;*****************************************************************
;
; lw_exists                 [si] hat jetzt adresse des sektors
;                           adressaufbau: hdnr(1)head(1)zyl(2)lba(4)
; CF nein!
;
;*****************************************************************
lw_exists
        push    ax
        push    bx
        push    cx
        push    dx
        push    si
        push    di
        push    es
        mov     ah,8
        mov     dl,[si]
        int     13h 
        pop     es
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        ret
;lw_exists endp

;*****************************************************************
;
; load_sector adresse: [si] hat jetzt adresse des sektors
;                           adressaufbau: hdnr(1)head(1)zyl(2)lba(4)
;                      es:di adresse im speicher
;
; ret: CF es ist ein fehler aufgetreten
;*****************************************************************
load_sector:
        push    ax
        push    bx
        push    cx
        push    dx
        push    si
        push    di
        push    es

        ;int 3
        call    lw_exists
        jnc     yes_load_exists
        ret
yes_load_exists:
        mov     cx,5
m_load_again:
        push    cx

        ; ist die bios erweiterung vorhanden
        mov     ah,41h
        mov     bx,55aah
        mov     dl,[si]
        int     13h
        jc      load_ext_not_supported

        ; aufpassen!!! das kann schief gehen,
        ; wenn si==di ist
        mov     bx,di
        mov     di,sector_lba_adresse
        mov     byte[di+len],10h     ; block len
        mov     byte[di+reserved],0h ; reserved
        mov     word[di+count],1     ; count
        mov     cx,[si+s_lba_adresse]
        mov     dx,[si+s_lba_adresse+2]
        mov     [di+lba_low],cx
        mov     [di+lba_low+2],dx
        mov     word[di+lba_high],0
        mov     word[di+lba_high+2],0
        mov     dl,[si+s_hdnr]
        mov     [di+buf_seg],es
        mov     [di+buf_off],bx
        mov     ah,42h
        push    si
        mov     si,di
        int     13h
        pop     si
        jmp     load_next_try

load_ext_not_supported:
        call    test_for_1024
        ; ZF
        jz      load_ext_not_supported2
        pop     cx
        stc
        jmp     leave_load_sector

load_ext_not_supported2:
        mov     ax,0201h ; read(2) (1)-sector
        mov     bx,di
        mov     dx,[si]
        mov     cx,[si+2]
        int     13h
load_next_try:
        pop     cx
        jnc     leave_load_sector
        mov     ah,0
        int     13h ; reset
        dec     cx
        jnz     m_load_again
        stc     ; set CF
leave_load_sector:

        pop     es
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        ret
;load_sector endp

;*****************************************************************
;
; is_in_hidingmap
;
; al:zeichen [bx]:hidingMap
;
; ZF ja, ist ax=0010h   - sonst ax=0000h
;
;*****************************************************************
is_in_hidingmap:
        push    bx
        push    cx
        mov     cx,HIDINGLEN     ; hidingmap ist 0 terminiert oder
                                 ; HIDINGLEN lang
m_search_start:
        mov     ah,[bx]
        cmp     ah,0             ; ende der hidingmap
        jz      m_hiding_notfound
        cmp     ah,al            ; diese Partition(al) in der hidingMap
        jz      m_hiding_found   ; verstecke diese partition!!!
        inc     bx
        dec     cx
        jnz     m_search_start
m_hiding_notfound:
        or      al,al            ; reset ZF
        mov     al,ch            ; mov ax,0
        mov     ah,ch
        jmp     m_end_search
m_hiding_found:
        mov     al,10h
        xor     ah,ah            ; set ZF
m_end_search:
        pop     cx
        pop     bx
        ret
;is_in_hidingmap endp


;*****************************************************************
;
; load_and_compare  [si] -hiding entry
;
; laedt sektor aus [si+2] und vergleicht partitionseintrag [si+1]
; mit dem aus dem sektor. sektor steht in sector_buffer
; und der partitionseintrag in [di]...
;
; ZF eintrag stimmt
;
;*****************************************************************
load_and_compare:
        push    cx
        push    ax
        push    si
        ; si soll auf sektoradresse zeigen
        add     si,2
        ; unter di sind 512 bytes reserviert
        mov     di,sector_buffer
        ; laedt sector mit adresse si nach es:di
        ; "partitionstabelle" kann auch eine erweiterte sein
        call    load_sector
        jc      load_and_compare_fail

        mov     al,[si-1]        ; al index in partitionstabelle
        mov     ah,10h           ; laenge eines partitionseintrages
        mul     ah               ; ax mul al*ah
        add     di,ax            ; di partitionseintrag des zu versteckenden laufwerkes
        add     di,01beh         ; 1. eintrag in partitionstabelle
                                 ; vergleiche erstmal mit dem hide_entry
                                 ; und wenn das ok ist, aendere part-id
                                 ; di partitionseintrag
                                 ; part_id's mit der id 0x11, 0x14, 0x16,
                                 ;                      0x1b, 0x1c, 0x1e
                                 ; werden wie normale behandelt
        mov     al,[di+part_id]
        mov     ah,al
        cmp     al,11h
        jz      m_reset_bit4
        cmp     al,14h
        jz      m_reset_bit4
        cmp     al,16h
        jz      m_reset_bit4
        cmp     al,1bh
        jz      m_reset_bit4
        cmp     al,1ch
        jz      m_reset_bit4
        cmp     al,1eh
        jnz     m_noreset_bit4
m_reset_bit4:
        and     [di+part_id],byte 0efh
m_noreset_bit4:
        mov     al,[di+active]
        mov     [di+active],byte 0    ; active flag intessiert nicht
        ; di zeigt im moment auf den partitionseintrag
        ; si zeigt im moment auf die sektoradresse
        ; jetzt zeigt si auf hidingentry.partitionentry
        ; skip sektoradresse -  si vergleich di
        add     si,8
        mov     cx,8
        rep     cmpsw
        jnz     load_and_compare_fail
        ; wenn der eintrag in der partitionstabelle nicht stimmt, vergiss diese
        ; partition und gehe zur naechsten, sonst :
        sub     di,10h
        mov     [di+active],al
        mov     [di+part_id],ah  ; alte partitions id wiederherstellen
        xor     al,al ; set ZF
        jmp     load_and_compare_fits
load_and_compare_fail:
        mov     al,1
        or      al,al ; reset ZF
load_and_compare_fits:
        pop     si
        pop     ax
        pop     cx
        ret
;load_and_compare endp


;*****************************************************************
;
; save_sector adresse: si hat jetzt adresse des sektors
;                         adressaufbau: hdnr(1)head(1)zyl(2)lba(4)
;                      di saveadresse
;
; ret: CF fehler aufgetreten
;*****************************************************************
save_sector:
        push    ax
        push    bx
        push    cx
        push    dx
        push    si
        push    di
        push    es

        call    lw_exists
        jnc     yes_save_exists
        ret
yes_save_exists:
        mov     al,[_par_config]
        and     al,CFG_NO_WRITE
        stc
        jnz      m_save_ret

        mov     cx,5
m_save_again:
        push    cx

        ;int3 ; klappt noch nicht - win9x feature
        ;int3 ; sicher ist sicher

        mov     ah,41h
        mov     bx,55aah
        mov     dl,[si]
        int     13h
        jc      saved_ext_not_supported

        ; aufpassen!!! das kann schief gehen,
        ; wenn si==di ist
        mov     bx,di
        mov     di,sector_lba_adresse
        mov     byte[di+len],10h     ; block len
        mov     byte[di+reserved],0h ; reserved
        mov     word[di+count],1     ; count
        mov     cx,[si+s_lba_adresse]
        mov     dx,[si+s_lba_adresse+2]
        mov     [di+lba_low],cx
        mov     [di+lba_low+2],dx
        mov     word[di+lba_high],0
        mov     word[di+lba_high+2],0
        mov     dl,[si+s_hdnr]
        mov     [di+buf_seg],es
        mov     [di+buf_off],bx
        mov     ah,43h
        mov     al,1    ; verify write
        push    si
        mov     si,di
        int     13h
        pop     si
        jmp     save_next_try

saved_ext_not_supported:
        call    test_for_1024
        ; ZF
        jz      saved_ext_not_supported2
        pop     cx
        stc
        jmp     m_save_ret
saved_ext_not_supported2:
        mov     ax,0301h ; write(3) (1)-sector
        mov     bx,di
        mov     dx,[si]
        mov     cx,[si+2]
        int     13h
save_next_try:
        pop     cx
        jnc     m_save_ret

        mov     ah,0
        int     13h ; reset
        dec     cx
        jnz     m_save_again
        stc
m_save_ret:
        pop     es
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        ret
;save_sector endp

;*****************************************************************
;
; MENU:
;
;*****************************************************************

menu
;    proc    near
        mov     bp,_entries+entryname
        mov     cx,WINWIDTH-4
;        mov     cx,ENTRW
        mov     dh,FIRSTENT ; dh: y dl: x
        mov     dl,WINX+2
;        mov     dl,(80-ENTRW)/2
m2:     mov     ah, byte[selected_entry]
        cmp     dh,ah
        jz      m3
        mov     bh,0
        MOV_BL_COL_MENU  ; hellblaue Schrift auf blauem grund
        jmp     m4
m3:     mov     bh,0
        MOV_BL_COL_SEL
m4:     cmp     byte [es:bp-1],0
        jz      m7
        mov     ax,1300h   ; write stringxy
        int     10h
        add     bp,PARTSIZE
        inc     dh
        cmp     dh,FIRSTENT+MAXENTRIE
        jnz     m2
m7:     ret
;menu    endp


;*****************************************************************
;
; MAIN
;
;*****************************************************************

start_boot  :
        cld
        push    es
        push    ds
        push    bp

        push    cs
        push    cs
        pop     ds
        pop     es


        mov     ah,1            ; setzte cursor
        mov     cx,2000h        ; ch:0xxlllll xx=01 unsichtbar
        int     10h

        call    BOOTMGR_clrscr
        call    window

        mov     ax,[_par_wartezeit]
        mov     bx,printtime
        call    timer_start

m12:    mov     ah,1
        int     16h
        jz      m6
        mov     ah,0
        int     16h
        jmp     m12

m6:     call    menu
m8:     call    timer_reached
        jz      m15  ; ersten markierten eintrag
        mov     ah,1
        int     16h ; taste gedrueckt?
        jz      m8
        ;call    remove_counter
        call    timer_STOP
        mov     ah,0
        int     16h ; ah=50h:down ah=48h:up
        mov     bx,ax
        cmp     bh,50h
        jnz     m5
        ; selektierten eintrag berechen
        mov     al,byte[selected_entry]
        cmp     al,FIRSTENT+MAXENTRIE-1 ; sind am schluss
        jge     m8

        sub     al,FIRSTENT-1
        mov     ah,PARTSIZE
        mul     ah
        add     ax,_entries ; ist der naechste eintrag belegt
        mov     bx,ax
        cmp     byte[bx],0
        jz      m8
        inc     byte[selected_entry]
        jp      m6

m5:     cmp     bh,48h
        jnz     m9
        mov     al,byte [selected_entry]
        cmp     al,FIRSTENT ; sind am anfang
        jle     m8
        dec     byte [selected_entry]
        jp      m6

m9:     cmp     bl,0dh
        jnz     m6
        ; ****************************************
        ; *
        ; *  <ENTER> key
        ; *
        ; ****************************************
m15:    mov     al,byte [selected_entry]
        sub     al,FIRSTENT
        mov     ah,PARTSIZE
        mul     ah
        add     ax,_entries+disk ; jetzt haben wir den eintrag fuer disk
        mov     bx,ax

        ;int 3
        mov     dl,[bx]   ; 1. festplatte
        inc     bx
        mov     ch,[bx]   ; 2. niederwerigsten 8 bit der cylinder#
        inc     bx
        mov     cl,[bx]   ; 3. bit 0-5 sector number 6-7 cylinder#
        inc     bx
        mov     dh,[bx]   ; 4. kopf
        inc     bx

        mov     ax,040h
        mov     es,ax
        mov     al,[bx]      ; schreibe parameter byte nach 0x40:0xf0
        mov     di,0f0h
        mov     [es:di],al
        push    ds
        pop     es           ; es: ist wieder gleich ds:

        add     bx, hiding_map-parameter ; skip parameterbyte + skip lba-adress
        ;add     bx,5                    ; and goto hiding map
                              ; hiding map max. HIDINGLEN lang
                             ; [bx]-[bx+HIDINGLEN-1] ist tabelle der zu versteckenden
                             ; laufwerke
        mov     si,_hide      ; [si] laufwerksname - alle partitionen
m_all_partitions_next:
        cmp     byte[si],0
        jnz     m_all_partitions_nexta
        jmp     m_all_partitions_quit
                             ; si - hidingentry  bx - hiding map
m_all_partitions_nexta:
        call    load_and_compare
        ; hier wird geschaut, ob der eintrag in hidingmap
        ; mit der partitionstabelle uebereinstimmt
        jnz     m_all_partitions_n
        ; ZF gut , sonst schlecht
        ; partitionstabelle geladen, verglichen, alles OK
        ; nun noch verstecken oder sichtbar machen [si]=hiding_entry
        mov     al,[si]

        ; hiding map ist in bx
        call    is_in_hidingmap
        ; jnz     m_all_partitions_n - argl das interessiert nicht
        ; sondern nur al=0 oder al=10h
        ; so al war also in hiding map, nun noch schauen, ob sich etwas aendert
        mov     ah,[di+part_id]
        and     ah,10h
        ; aendert sich da hiding bit
        xor     al,ah
        ; nein? , dann naechster eintrag
        jz      m_all_partitions_n
        ; ja, er aendert sich
        push    si
        add     si,2
        mov     al,[di+part_id]
        mov     ah,al;   ; xor bit4  !a*10h OR a*0efh
        not     al
        and     al,10h
        and     ah,0efh
        or      al,ah

        mov     [di+part_id],al
        mov     di,sector_buffer

        cmp     byte[_par_test_mode],_TEST_
        jz      m_nosave
        call    save_sector
m_nosave:

        pop     si
m_all_partitions_n:
        add     si,HIDSIZE
        jmp     m_all_partitions_next
m_all_partitions_quit:
        ; bx zeigt auf passwd
        sub bx,(9+13+32+1)
        ;int 3
        ; -lbaadr-parameter-head-sek05cyl67-lower8cyl
        ; -hdnr-addinfos-entryname-isEntry
        mov     al,[bx+flagfield]
        and     al,FLAG_SET_ACTIVE_FLAG
        jz      dont_set_active_flag
        mov     si,mbradr
        mov     di,sector_buffer
        mov     al,[bx+disk]
        mov     ah,0
        mov     [si],ax
        call    load_sector
        jc      dont_set_active_flag

        push    dx
        push    cx
        ; jetzt nach der lba-adresse suchen
        ; und den eintrag markieren
        mov     cx,[bx+lba_adresse]
        mov     dx,[bx+lba_adresse+2]
        ; di zeigt auf die partitionstabelle des bootlaufwerkes
        add     di,1beh
        mov     ah,0 ; set sector_changed=false
        mov     al,4 ; 4 eintraege

weiter_suchen:
        cmp     [di+rel_start],cx
        jnz     reset_active
        cmp     [di+rel_start+2],dx
        jnz     reset_active
        ; partitionseintrag gefunden
        ; setze aktive flag
        cmp     [di+active],byte 80h
        jz      again_set_active ; ist schon aktiv
        mov     [di+active],byte 80h
        mov     ah,1 ; set sector_changed=true!!
        jmp     again_set_active
reset_active:
        cmp     [di+active],byte 00h
        jz      again_set_active ; ist nicht-aktiv
        mov     [di+active],byte 00h
        mov     ah,1 ; set sector_changed=true!!
        jmp     again_set_active
again_set_active:
        add     di,16
        dec     al
        jnz     weiter_suchen
        cmp     ah,0
        jz      dont_save_mbr

        mov     si,mbradr
        mov     al,[bx+disk]
        mov     [si],al
        mov     di,sector_buffer

        cmp     byte[_par_test_mode],_TEST_
        jz      dont_save_mbr
        call    save_sector

dont_save_mbr:
        pop     cx
        pop     dx


dont_set_active_flag:

        call    BOOTMGR_clrscr
        mov     ax,0500h ; set active page 0
        int     10h
        mov     si,bx

        cmp     byte[_par_test_mode],_TEST_
        jz      main_m2

        ;_NOTEST_
        pop     bp ; stack wieder aufraeumen - siehe start_boot:
        pop     es
        pop     es
        mov     ax,0
        mov     es,ax
        mov     bx,sector_adresse
        mov     di,7c00h            ; es:bx to buffer
main_m2:
        cmp     byte[_par_test_mode],_TEST_
        jnz     main_m3

        ; _TEST_
        push    cs
        pop     es
        mov     di,sector_buffer
main_m3:
        ; cx = sektor
        ; dx = zyl + head
        ; lade sektor
        ; bx dest-sektor
        ; si PartitionEntry
        ;int 3
        mov     al,[si+disk]
        mov     ah,[si+head]
        mov     [bx],ax
        mov     al,[si+sek05cyl67]
        mov     ah,[si+lower8cyl]
        mov     [bx+2],ax
        mov     ax,[si+lba_adresse]
        mov     [bx+4],ax
        mov     ax,[si+lba_adresse+2]
        mov     [bx+6],ax
        push    si
        mov     si,bx
        call    load_sector
        pop     si
        jc      boot_load_failed

        ;mov     al,01h          ; 1 sektoren lesen
        ;mov     ah,02h          ; up(2): read sector
        ;int     13h
        ; jetzt ist das dingens geladen nun noch bootlaufwerk
        ; eintragen
        ;int 3
        mov     al,[si+flagfield]
        and     al,FLAG_SET_BYTE36_TO_HDNR
        jz      bootlw1
        mov     al,[si+disk]
        mov     [es:di+36],al
bootlw1:
        mov     al,[si+flagfield]
        and     al,FLAG_SET_BYTE1FD_TO_HDNR
        jz      bootlw2
        mov     al,[si+disk]
        mov     [es:di+1fdh],al
bootlw2:
        mov     al,[si+flagfield]
        and     al,FLAG_SET_BYTE53_TO_HDNR
        jz      bootlw3
        mov     al,[si+disk]
        mov     [es:di+53h],al
bootlw3:
bootlwend:
        cmp     byte[_par_test_mode],_TEST_
        jz      main_ends
        ; im testmode springt er zurueck
        ; sonst zum anfang dieses programms
        ; _NOTEST_
        jmp     0:7c00h
main_ends:
        mov     ax,-1 ; ret=true alles ok
        pop     bp ; borland-c++ will seine umgebung wieder haben
        pop     ds
        pop     es
        retf;
boot_load_failed:
        ; jetzt sind wir im testmode oder auch nicht
        ; wenn nicht ist der stack bereits aufgeraeumt und
        ; wird koennen zum anfang springen
        cmp     byte[_par_test_mode],_TEST_
        jz      boot_load_failed_test
        jmp     main_boot_

boot_load_failed_test:
        mov     ax,0 ; ret=false
        pop     bp ; stack wieder aufraeumen - siehe start_boot:
        pop     ds ; borland-c++ umgebung wieder herstellen
        pop     es
        retf
_hide:   times 25*HIDSIZE db (0)  ; HidingEntry <0,0,0,0,0,0,0> ; max 25 dos-partitionen
        db 00h; // endemarke                                 ; c-z
_main_boot_ends:

; temporary variables

on_timer_call:      dw default_timer_proc
timer_value:        dw 0
old_timer_off:      dw 0
old_timer_seg:      dw 0
sector_adresse:     times 16  db 0 ; avoid to overwrite data !?
                                   ; what does that means????
sector_lba_adresse: times 16  db 0 ; for lba-load
sector_buffer:      times 512 db 0 ; just some fill bytes
                                   ; so we can easily cut this programm at a
                                   ; 512 bytes boundary and save into
                                   ; disc sectors

; *******************************************************************
; start_boot   endp
; *******************************************************************

