// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial use without permit.                                *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************
#include <baselib/all.h>

#include <stdlib.h>
#include <stdio.h>

#include "biosdefs.h"
#include "asmdefs.h"
#include "impsett.h"

// laenge in bytes
// das eigentliche programm darf nur
// 16*512 bytes lang sein min(sektoren_auf_spur_0)-Partitionssektor
// es muesste also reichen
#define BOOTMGR_LEN  16*512

ImportSetting::ImportSetting()
:bootmgr_size(0)
,bootmgr_bin(NULL)
,conf(NULL)
,entries(NULL)
{
  // printf("%d\n",sizeof(MBR_Mr_Boot));

#pragma warning * 9
   assert (sizeof(MBR_Mr_Boot)==512);

  bootmgr_bin=(Sector *)malloc(BOOTMGR_LEN);
#pragma warning * 0

  if (!bootmgr_bin)
    return;
  bool ret=BIOSLoadSectorLBA(0x80,0,bootmgr_bin);
  if (!ret)
    return;
  const MBR_Mr_Boot & mbr=bootmgr_bin->mrboot;
  if (strncmp(mbr.mrboot,"MrBoot",6)!=0)
    return; // kein MrBoot Bootmanager
  // ab version 4.08 ( erste freie version) gibt es
  // hdnr , len
  // also kein versionstest
  assert(mbr.boot_seccount<17);
  byte hdnr    =mbr.boot_disk;
  byte seccount=max(mbr.boot_seccount,(byte)16);
  // achtung ab jezt ist mbr & nicht mehr gueltig !!!
  // in den Speicherplatz dieses pointers kann ueber
  // *s geschrieben werden
  Sector *s=bootmgr_bin;
  dword  lbaADR=1; // sektor #2

  for (int i=0; i<seccount; i++,s++,lbaADR++)
  {
    ret=BIOSLoadSectorLBA(hdnr,lbaADR,s);
  }
  if (!ret)
    return;
  conf=&bootmgr_bin->bootmgr;
  entries=(par_partitionentry*)(((byte*)conf)+conf->par_partition_starts_offset);
  // konfiguration eingelesen
}

ImportSetting::~ImportSetting()
{
  if (bootmgr_bin)
    free(bootmgr_bin);
}



