// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial use without permit.                                *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************

#include <baselib/all.h>

#include <conio.h>
#include <dos.h>

#include "biosdefs.h"
#include "asmdefs.h"
#include "impsett.h"
#include "mouse.h"
#include "partentry.h"
#include "version.h"
#include "mywin.h"
#include "licence.h"
//#include "debug.h"
#include "myargs.h"

//extern unsigned _stklen=0x8000;


byte col_80_25[10]= { CYAN*16, 0x1f, CYAN*16|YELLOW, CYAN*16|8, 0x1b,
                     CYAN, 0x70|1,  0x10|YELLOW,0x0f, RED*16|WHITE  };
byte col_mono[10]=  { 0x70, 0x07, 0x70, 0x0f, 0x0f, 0x81, 0x70, 0x0f ,0x0f,0x70 };

const byte *cols=col_80_25;

class HidingMapEntry
{
  par_hidingmapentry h;
  //char           dosName; //CDE...
  //char           hdnr;
  //char           index_in_table;
  //zylsec         start_zyl;
  //byte           head;
  //PartitionEntry line;
public:
  // reset bit 5
  HidingMapEntry(char dosName, byte hdnr, byte index_in_table,
                 zylsec start_zyl, byte head,dword lbaOFS,
                 const PartitionEntry &line)
  {
   h.dosName  =dosName;   h.hdnr=hdnr; h.index_in_table=index_in_table;
   h.start_zyl=start_zyl; h.head=head; h.line=line;
   switch (h.line.part_id | 0x10)
   {
      // fat2
      case 0x11:
      // fat16 <32mb
      case 0x14:
      // fat16>32mb
      case 0x16:
      // fat32
      case 0x1b:
      // fat32 lba
      case 0x1c:
      // fat16 lba
      case 0x1e:
        h.line.part_id=h.line.part_id & ~0x10;
        break;
      default:
        break;
   }
   // dieses feld wird im BOOTMANAGER erst auf 0 gesetzt
   // und dann mit h.line verglichen - deswegen hier auch 0
   h.line.active=0;
   //
   h.lbaADR=lbaOFS;
  }
  const par_hidingmapentry & GetHidingMapEntry() const { return h; }
};

PAR_TYPE_ENTRY sec_lookup[FLOPPYBOOTSEC+1]=
{
  {UNKNOWN      ,0                        },
  {UNKNOWNDOS   ,FLAG_SET_BYTE36_TO_HDNR  },
  {WIN9X        ,FLAG_SET_BYTE36_TO_HDNR  },
  {FAT32        ,0                        },
  {DRDOS60      ,FLAG_SET_BYTE1FD_TO_HDNR },
  {NWDOS7       ,FLAG_SET_BYTE36_TO_HDNR  },
  {OPENDOS7     ,FLAG_SET_BYTE36_TO_HDNR  },
  {MSDOS401     ,FLAG_SET_BYTE36_TO_HDNR  },
  {LINUX        ,0                        },
  {OS2BOOTMAN   ,FLAG_SET_BYTE53_TO_HDNR  },
  {OS2HPFS      ,FLAG_SET_BYTE36_TO_HDNR  },
  {IBMDOS       ,FLAG_SET_BYTE36_TO_HDNR  },
  {FLOPPYBOOTSEC,0                        }
};

//byte doslw[]={0x01,0x04,0x06,0x07,0x0b,0x0c,0x0e,
//              0x11,0x14,0x16,0x17,0x1b,0x1c,0x1e};

EditString::EditString(const char *t,bool c,bool _move,const char *filter)
:AZString(t)
,isConst(c)
,cursor(0)
,editLen(0)
,moveCursor(_move)
,filter_str(filter)
{
  if (isConst || !moveCursor)
    return;
  cursor=strlen(t);
  const char *endPtr=t+strlen(t)-1;
  while(endPtr>=t && *endPtr==' ')
  {
    endPtr--;
    cursor--;
  }
  if (cursor)
    editLen=cursor;
}

/*_WindowListe_::_WindowListe_(int _x,int _y,int _w,int _h, int _style)
:Window(_x,_y,_w,_h) // ohne rand
,listCount(0)
,topItem(0)
,listVisible(h)
,selectItem(-1)
,style(_style)
{
}

void _WindowListe_::AddItem(ListItemBase *it)
{
  assert(it);
  if (!it)
    return;
  liste.AddTail(it);
  listCount++;
  // biite nicht den style aendern
  // lieber die abfrage nach Paint()
  //if (listCount>listVisible)
  //  style&=~LB_NOVSCROLLBAR;
}

void _WindowListe_::SelectItem(int count)
{
  if (count==-1)
  {
    selectItem=count;
    return;
  }
  if (count>=listCount)
  {
    return;
  }
  // wenn selected item nicht mehr sichtbar ist
  if (count!=-1)
  {
    if (count<topItem || count>=topItem+listVisible)
    {
      // aber bitte nur soweit wie auch noch elemente da sind
      topItem=min(max(0,topItem+count-selectItem),
                  max(0,listCount-listVisible) );

    }
  }
  //
  selectItem=count;
}


ListItemBase *_WindowListe_::GetItem()
{
  int count=0;
  if (selectItem==-1)
    return NULL;

  FORALL(liste,ListItemBase)
  {
    if (count==selectItem)
      return &it();
    count++;
  }
  return NULL;
}

void _WindowListe_::RemoveItem(int _count)
{
  int count=0;

  FORALL(liste,ListItemBase)
  {
    if (count==_count)
    {
      if (count==selectItem)
        selectItem=-1;
      listCount--;
      it.Remove();
      return; // bitte!!! als naechstes macht FORALL
              // ein it++ und der geht schief wenn it==0 ist
    }
    count++;
  }
}

void _WindowListe_::PaintItem(const ListItemBase &it,bool selected)
{
  if (selected)
      textattr(COL_SELECT);
    cprintf("%s",it.Text());
  if (selected)
      textattr(COL_NORMAL);
}

void _WindowListe_::Paint()
{
  int myy=y+2;// +1 fuer titel zeile +1 fuer 1-basiert
  int myx=x+w;

  if ((style&LB_NOVSCROLLBAR)==0 && listCount>listVisible)
  {
    ::gotoxy(myx,myy);
    textattr(COL_BW);
    putch('');
    textattr(COL_NORMAL);
    myy++;

    // i=2; heisst: 2 zeichen=oben+unten weglassen fuer pfeile
    for (int i=2;i<h;i++,myy++)
    {
      ::gotoxy(myx,myy);
      putch('');
    }
    textattr(COL_BW);
    ::gotoxy(myx,myy);
    putch('');
  }
  else
  {
    textattr(COL_NORMAL);
    for (int i=1;i<=h;i++,myy++)
    {
      ::gotoxy(myx,myy);
      putch(RIGHT);
    }
  }

  textattr(COL_NORMAL);
  myy=y+2;
  myx=x+1;
  ::gotoxy(myx,myy);
  int curItem=0;
  FORALL(liste,ListItemBase)
  {
    if (curItem>=topItem+listVisible)
      break;
    if (curItem<topItem)
    {
      curItem++;
      continue;
    }
    ::gotoxy(myx,myy);

    PaintItem(it(),(curItem==selectItem)?true:false);
    curItem++;
    myy++;
  }
  // mal schauen ob auch leere zeilen in der liste sind
  for (;curItem<topItem+listVisible;curItem++,myy++)
  {
    ::gotoxy(myx,myy);
    for (int i=1; i<w;i++) putch(SPACE);
  }
}

void *_WindowListe_::GetItemByID(int id)
{
  int count=0;

  FORALL(liste,ListItemBase)
  {
    const ListItemBase &item=it;
    if (item.GetID()==id)
    {
      return &it();
    }
    count++;
  }
  return 0;
}

const void *_WindowListe_::GetItemByID(int id) const
{
  int count=0;

  ListItemBaseDList &el=(ListItemBaseDList &) liste;

  FORALL(el,ListItemBase)
  {
    const ListItemBase &item=it;
    if (item.GetID()==id)
    {
      return &it();
    }
    count++;
  }
  return 0;
}

const ListItemBase *_WindowListe_::GetItem() const
{
  int count=0;
  if (selectItem==-1)
    return NULL;

  ListItemBaseDList &el=(ListItemBaseDList &) liste;
  FORALL(el,ListItemBase)
  {
    if (count==selectItem)
      return &it();
    count++;
  }
  return NULL;
}
*/


PartitionWindow::PartitionWindow(PartEntryList &pe)
:Window(PAR_X,PAR_Y,PAR_W,PAR_H)
,partList(PAR_X+3,PAR_Y+3,PAR_W-1,PAR_H-2, LB_DEFAULT )
,peList(pe)
{
  // in peList alle moeglichen partitionen
  int index=0;
  FORALL(peList,PartEntry)
  {
    ListItemPartEntry *li=new ListItemPartEntry(
                              it().GetTextLong(),
                              LISTITEM_PARTENTRY+index++,
                              it());
    if (li)
    {
      partList.AddItem(li);
    }
  }
  partList.SelectItem(0);
}

void PartitionWindow::Up()
{
  int sel=partList.GetSelectedItem();
  if (sel>0)
  {
    partList.SelectItem(--sel);
    partList.Paint();
  }
}

void PartitionWindow::Down()
{
  int sel=partList.GetSelectedItem();
  int max=partList.GetItemCount();
  sel++;
  if (sel<max)
  {
    partList.SelectItem(sel);
    partList.Paint();
  }
}

void PartitionWindow::Top()
{
  int sel=partList.GetSelectedItem();
  if (sel>0)
  {
    partList.SelectItem(0);
    partList.Paint();
  }
}

void PartitionWindow::Bottom()
{
  int sel=partList.GetSelectedItem();
  int max=partList.GetItemCount();
  if (sel<max-1 && max>0)
  {
    partList.SelectItem(max-1);
    partList.Paint();
  }
}

void PartitionWindow::Paint()
{
  Window::Paint();
  partList.Paint();

  gotoxy(0,0);
  textattr(COL_HEADLINE);

  cprintf("  HD#    LW: Bezeichnung  Partitionstyp             "
          " Typ           Gre\n");
}

const PartEntry & PartitionWindow::GetSelectedItem()
{
  return partList.GetItem()->GetPartEntry();
}



HelpWindow::HelpWindow()
:Window(0,0,17,PAR_Y-1)
{
}

void HelpWindow::Paint()
{
  textattr(COL_NORMAL);
  Window::Paint();
  gotoxy(-1,h);
  putch(BR_RIGHT);

  //gotoxy(1,0);
  // 1basiert+2xrand
  // 1basiert+titelzeile+2xrand
  window(x+1+2,y+2+2,x+w+1,y+h+1);

  cprintf("%s",text.Text());
  window(1,1,80,25);
}

void HelpWindow::SetText(const char *t)
{
  text=t;

// paint
  textattr(COL_NORMAL);
  gotoxy(-1,h);
  putch(BR_RIGHT);

  //gotoxy(1,0);
  // 1basiert+2xrand
  // 1basiert+titelzeile+2xrand
  window(x+1+2,y+2+2,x+w+1,y+h);

  cprintf("%s",text.Text());
  window(1,1,80,25);
}

bool  EditString::SetChar(char c)
{
  if (cursor==Len())
    return false;
  if (filter_str.Len() && strchr(filter_str,c)==NULL)
    return false;
  char *p=(char *)Text();
  p[cursor]=c;
  return true;
}

bool EditIntString::SetChar(char c)
{
  if ( (c<'0' || c>'9') && c!=0x20)
    return false;
  return EditString::SetChar(c);
}

bool EditFlagString::SetChar(char c)
{
  if (c!=0x20 && c!='x' && c!='X')
    return false;
  char *t=(char *)Text();
  if (*t)
  {
    if (*t==' ')
      *t='x';
    else
      *t=' ';
  }
  return true;
}

//******************
//*                *
//* EditList       *
//*                *
//******************
const EditString & EditList::operator[](int index) const
{
  int count=0;
  EditList &el=(EditList &) *this;

  FORALL(el,EditString)
  {
  #ifdef DEBUG
    const EditString & es=it;
    es.Text(); // warning soll weg
  #endif
    if (count==index)
      return it;
    count ++;
  }
  return *(EditString*)First()->Data();
}


void EditList::AddVStr(const char *t,const char *filter_str)
{
  EditString *e=new EditString(t,false,true,filter_str);
  AddTail(e);
}


int WindowEditListe::GetHItemCount()
{
  int numEntry=0;
  int count   =0;
  FORALL(liste,ListItem)
  {
    if (selectItem==numEntry)
    {
      EditList &edl=*(EditList*)it().Data();
      FORALL(edl,EditString)
        if (!it().IsConst()) count++;
    }
    numEntry++;
  }
  return count;
}

void WindowEditListe::PaintItem(const ListItemBase &__it,bool selected)
{
  ListItem &_it=(ListItem &)__it;

  EditList &edl=*(EditList*)_it.Data();
  int numEntry=0;
  bool cursorExeeds=false; // cursor steht 1 hinter dem letzten feld

  char filter[]="\x7\x9\xa\xd\27";

  FORALL(edl,EditString)
  {
    EditString &es=it;

    bool _selected=selected && (numEntry==h_selected) && !es.IsConst();
    const char *t=es.Text();
    int i=0;

                        // falls jemand AZString("") anhaengt!
    if (cursorExeeds && es.Len())
    {
      textattr(COL_CUR);
      putch(*t);
      t++;
      i++;
      cursorExeeds=false;
      textattr(COL_NORMAL);
    }
    if (_selected)
      textattr(COL_SELECT);

    if (!es.IsConst() && !_selected )
      textattr(COL_EDIT);

    for (; i<es.Len();i++,t++)
    {
      if (_selected && i==es.GetCursor())
        textattr(COL_CUR);
      char c=*t;
      if (strchr(filter,c))
        c='.';
      putch(c);
      if (_selected && i==es.GetCursor())
        textattr(COL_SELECT);
    }

    if (!es.IsConst() )
      textattr(COL_NORMAL);


    if (_selected && es.GetCursor()==es.Len())
    {
      cursorExeeds=true;
    }

    if (_selected)
      textattr(COL_NORMAL);
    if (!es.IsConst())
      numEntry++;
  }
}

bool WindowEditListe::InsertChar(char c)
{
  int numEntry=0;
  int count   =0;

  FORALL(liste,ListItem)
  {
    if (selectItem==numEntry)
    {
      EditList &edl=*(EditList*)it().Data();
      FORALL(edl,EditString)
      {
        if (!it().IsConst() )
        {
          if (h_selected==count)
          {
            EditString &str=it;

            switch (c)
            {
              case 8:
              {
                int cr      = str.GetCursor();
                int len     = str.Len();
                int editLen = str.EditLen();
                if (!str.MoveCursor() && str.Len())
                {
                  str.SetChar(0x20);
                }
                if (cr>0)
                {
                  str.SetCursor(--cr);
                  str.SetChar(0x20);
                  len--; // len ist jetzt index des letzten zeichens
                  str.SetEditLen(--editLen);
                  if (cr<len)
                  {
                    char *p=(char *)str.Text();
                    memmove(p+cr,p+cr+1,len-cr);
                    p[len]=' ';
                  }
                }
                Paint();
                break;
              }
              case 7:    // bell
              case 9:    // hoch
              case 10:   // runter
              case 13:   // enter
              case 27:   // esc
                return false;
              default :
              {
                int cr  = str.GetCursor();
                int len = str.Len();
                if (cr>=len)
                {
                  return false;
                }

                bool ret=str.SetChar(c);
                if (!ret)
                {
                  return false;
                }
                //if ret && str.Move...
                if (str.MoveCursor())
                {
                  str.SetCursor(++cr);
                  if (c!=0x20)
                  {
                    int editLen=str.EditLen();
                    str.SetEditLen(max(editLen,cr));
                  }
                }
                Paint();
                return true;
              }
            }
          }
          count++;
        }
      }
    }
    numEntry++;
  }
  return false;
}

EditString * WindowEditListe::GetSelectedEditString()
{
  int numEntry=0;
  int count   =0;

  if (selectItem==-1)
    return NULL;

  FORALL(liste,ListItem)
  {
    if (selectItem==numEntry)
    {
      EditList &edl=*(EditList*)it().Data();
      FORALL(edl,EditString)
      {
        if (!it().IsConst() )
        {
          if (h_selected==count)
          {
            EditString &str=it;
            return &str;
          }
          count++;
        }
      }
    }
    numEntry++;
  }
  // hier duerfte man nie ankommen
  assert(0);
  return NULL;
}

void WindowEditListe::SetCommand(char c)
{
  switch (c)
  {
    case 0x53: Entf();     break;
    // pfeil runter
    case 0x50: Down();     break;
    // pfeil hoch
    case 0x48: Up();       break;
    // pos1
    case 0x49:
    // page up
    case 0x47: Top();      break;
    // ende
    case 0x51:
    // page down
    case 0x4f: Bottom();   break;
    // pfeil rechts
    case 0x4d: Right();    break;
    // pfeil links
    case 0x4b: Left();     break;
    case 0x0f: ShiftTab(); break;
    case 0x09: Tab();      break;
    case 0x0d: Enter();    break;
    default:
      break;
  }
  Paint();
}

void WindowEditListe::Up()
{
  int sel=GetSelectedItem();
  if (sel>0)
    SelectItem(--sel);
}

void WindowEditListe::Down()
{
  int sel=GetSelectedItem();
  int max=GetItemCount();
  sel++;
  if (sel<max)
    SelectItem(sel);
}

void WindowEditListe::Top()
{
  int sel=GetSelectedItem();
  if (sel>0)
    SelectItem(0);
}

void WindowEditListe::Bottom()
{
  int sel=GetSelectedItem();
  int max=GetItemCount();
  if (sel<max-1 && max>0)
    SelectItem(max-1);
}

void WindowEditListe::Left()
{
  EditString * str=GetSelectedEditString();
  if (str)
  {
    int cr=str->GetCursor();
    if (cr)
    {
      str->SetCursor(--cr);
      Paint();
      return;
    }
  }
  ShiftTab();
}

void WindowEditListe::Right()
{
  EditString * str=GetSelectedEditString();
  if (str)
  {
    int cr  = str->GetCursor();
    int len = str->EditLen();
    if (cr<len)
    {
      str->SetCursor(++cr);
      Paint();
      return;
    }
  }
  Tab();
}

void WindowEditListe::Tab()
{
  int sel=GetSelectedItem();
  if (sel==-1)
    return;
  int hsel  = GetHSelectedItem();
  int hcount= GetHItemCount();
  hsel++;
  if (hsel<hcount)
  {
    HSelectItem(hsel);
    Paint();
    return;
  }
  int count=GetItemCount();
  sel++;
  if (sel<count)
  {
    HSelectItem(0);
    SelectItem(sel);
    Paint();
  }
}

void WindowEditListe::Enter()
{
  int sel=GetSelectedItem();
  if (sel==-1)
    return;
  int count=GetItemCount();
  sel++;
  if (sel<count)
  {
    HSelectItem(0);
    SelectItem(sel);
    Paint();
  }
}

void WindowEditListe::ShiftTab()
{
  int sel=GetSelectedItem();
  if (sel==-1)
    return;
  int hsel  = GetHSelectedItem();
  if (hsel>0)
  {
    HSelectItem(--hsel);
    Paint();
    return;
  }
  if (sel>0)
  {
    // erst eine zeile hoch
    SelectItem(--sel);
    // dan letztes item in DER DORTIGEN ZEILE
    HSelectItem(GetHItemCount()-1);
    Paint();
  }
}

void WindowEditListe::Entf()
{
  EditString * str=GetSelectedEditString();
  if (str)
  {
    int cr      = str->GetCursor();
    int len     = str->Len();
    int editLen = str->EditLen();

    if (cr<len)
    {
      if (editLen)
          str->SetEditLen(editLen-1);

      // move
      int movelen=len-cr-1;
      if (movelen && str->MoveCursor() )
      {
        char *dest=(char*)str->Text()+cr;
        char *src =(char*)str->Text()+cr+1;
        memmove(dest,src,movelen);
      }
      str->SetCursor(len-1);
      str->SetChar(0x20);
      str->SetCursor(cr);

      Paint();
      return;
    }
  }
}

BootEditWindow::BootEditWindow(const ImportSetting & im)
:inherited(PAR_X+2,PAR_Y+1,PAR_W,PAR_H,LB_NOVSCROLLBAR) // window ohne frame
// die liste faengt 1 weiter links an, falls mal
// mehr als 0..9 partitionseintraege moeglich sind
,partList   (PAR_X+2,PAR_Y+1,PAR_W,PAR_H,LB_DEFAULT )
{
//  EditList *edl=new EditList();
//  if (edl)
//  {
//    edl->AddCStr("Startverzgerung      :  ");
//    edl->AddVInt(" 0");
//    edl->AddCStr("  Sekunden");
//  }
//  ListItemEditList *li=new ListItemEditList(edl,LISTITEM_STARTVERZOEGERUNG);
//  if (li)
//  {
//    partList.AddItem(li);
//  }
  char buf[3]="25";
  bool unlimited=true;
  if (im.conf && im.conf->par_wartezeit!=0xffff)
  {
    sprintf(buf,"%02d",im.conf->par_wartezeit);
    unlimited=false;
  }

  EditList *edl=new EditList();
  if (edl)
  {
    edl->AddCStr("Wartezeit:            :  ");
    edl->AddVInt(buf);
    edl->AddCStr("  Sekunden");
  }

  ListItemEditList *li=new ListItemEditList(edl,LISTITEM_WARTEZEIT);
  if (li)
  {
    partList.AddItem(li);
  }

  edl=new EditList();
  if (edl)
  {
    edl->AddCStr("   unbeschrnkt       : [");
    edl->AddVFlg(unlimited);
    edl->AddCStr("]"); // fuer den cursor PaintItem() braucht das;
  }
  li=new ListItemEditList(edl,LISTITEM_UNBESCHRAENKT);
  if (li)
  {
    partList.AddItem(li);
  }

  GIVEARGS(MyArg,myargs);
  bool isMono;
  if (im.conf)
    isMono=(im.conf->par_cols[0]==0x07)?true:false;
  else
    isMono=myargs.monoColors.Get()?true:false;

  edl=new EditList();        
  if (edl)
  {
    edl->AddCStr("Bootmanagerfarben s/w : [");
    edl->AddVFlg(isMono);
    edl->AddCStr("]");
  }
  li=new ListItemEditList(edl,LISTITEM_MONO);
  if (li)
  {
    partList.AddItem(li);
  }

//  edl=new EditList();
//  if (edl)
//  {
//    edl->AddCStr("'Beep' beim Start     : [");
//    edl->AddVFlg(false);
//    edl->AddCStr("]"); // fuer den cursor PaintItem() braucht das;
//  }

//  li=new ListItemEditList(edl,LISTITEM_BEEPBEIMSTART);
//  if (li)
//  {
//    partList.AddItem(li);
//  }

//  li=new ListItem;
//  if (li)
// {
//    // aufraeumen nicht vergessen!!!
//    EditList *edl=new EditList();
//    edl->AddCStr("Administrator Passwort:  ");
//    edl->AddVStr("        ");
//    edl->AddCStr("  Besttigung:  ");
//    edl->AddVStr("        ");
//    edl->AddCStr(" "); // fuer den cursor PaintItem() braucht das;
//    li->data=edl;
//    partList.AddItem(li);
//  }

}


void BootEditWindow::Init()
{
//  inherited::Paint(); bitte im init nicht mehr zeichnen
  if (partList.GetSelectedItem()==-1)
    partList.SelectItem(0);
}

void BootEditWindow::Paint()
{
  inherited::Paint();
  partList.Paint();
}

bool BootEditWindow::InsertChar(char c)
{
  return partList.InsertChar(c);
}


//******************
//*                *
//* BootSelWindow  *
//*                *
//******************

BootSelWindow::BootSelWindow()
:inherited(18+1,1,78-18+1,PAR_Y-1,LB_DEFAULT )
{
}

void BootSelWindow::Init(PartEditWindow *sw)
{
  // dient nur zu Anzeige
  window(x+1,y+2,x+w,y+h+1);
  textattr(COL_NORMAL);
  clrscr();
  window(1,1,80,25);

  int i=0;

  ListItemEditListDList * l= & sw->partEditList.GetList();
  DeleteAll();

  FORALL(*l,ListItemEditList)
  {
    EditList & edl = *it().GetEditList();
    ListItem * li  = new ListItem(edl[0]+edl[1]+edl[3],&edl,LISTITEM_SELBOOT+i);
    if (li)
    {
      // Nr: Part-Bezeichnung ID
      AddItem(li);
    }
    i++;
  }
  Paint();
}

//******************
//*                *
//* InstallHinweis *
//*                *
//******************

InstallHinweis::InstallHinweis()
:inherited(18+1,0,78-18+1,PAR_Y-1,LB_DEFAULT )
{
}

void InstallHinweis::Paint()
{
  window(x+1,y+3,x+w-1,y+h+2);
  textattr(COL_NORMAL);
  clrscr();
  window(1,1,80,25);
  gotoxy(0,0);
  textattr(COL_NORMAL);
  cprintf("(a) Der Bootmanager wird in die Spur 0 der Festplatte 0 ");
  gotoxy(0,1);
  cprintf("und der StartupCode im MBR wird gendert. Die Partitions-");
  gotoxy(0,2);
  cprintf("tabelle wird nicht verndert. ");
  gotoxy(0,3);
  cprintf("(b) ist die sicherste Methode zum Testen. Hierbei werden");
  gotoxy(0,4);
  cprintf("vom Programm keine Daten im MBR gendert, sondern alle not-");
  gotoxy(0,5);
  cprintf("wendigen Informationen auf Diskette geschrieben. Die FAT");
  gotoxy(0,6);
  cprintf("wird berschrieben und die Daten unbrauchbar gemacht.");
  gotoxy(0,7);
  cprintf("Leider funktioniert das ");
  textattr(COL_IMPORTANT);
  cprintf("Verstecken nicht");
  textattr(COL_NORMAL);
  cprintf(" und das ");
  textattr(COL_IMPORTANT);
  cprintf("Booten");
  textattr(COL_NORMAL);
  cprintf(" nur");
  gotoxy(0,8);
  textattr(COL_IMPORTANT);
  cprintf("eingeschrnkt.");
  textattr(COL_NORMAL);


  cprintf(" Bitte also eine ");
  textattr(COL_IMPORTANT);
  cprintf("leere Diskette");
  textattr(COL_NORMAL);
  cprintf(" verwenden!");

  gotoxy(0,9);
  cprintf(">mit ");
  textattr(COL_IMPORTANT);
  cprintf("F8");
  textattr(COL_NORMAL);
  cprintf(" kann man sich schon mal den Bootmanager anschauen<");

  //  gotoxy(0,3);
  //  cprintf("(b) Im MBR wird nur ein Eintrag in der Partitionstabelle");
  //gotoxy(0,4);
  //cprintf("hinzugefuegt. Es muss noch mindestens einer frei und inner-");
  //gotoxy(0,5);
  //cprintf("halb der ersten 1024 Zylinder eine freie Spur vorhanden sein.");
}

//******************
//*                *
//* InstallEdit    *
//*                *
//******************

InstallEdit::InstallEdit()
:WindowEditListe(PAR_X+2,PAR_Y+1,PAR_W,PAR_H,LB_NOVSCROLLBAR) // window ohne frame
,writeToMBR(false)
,writeToDisk(true)
{
  EditList *edl=new EditList();
  if (edl)
  {
    // aufraeumen nicht vergessen!!!
    edl->AddCStr("Installation in MBR der 1. Festplatte  : (");
    edl->AddVFlg(false);
    edl->AddCStr(") (a)"); // fuer den cursor PaintItem() braucht mind. ein zeichen;
  }
  ListItemEditList *li=new ListItemEditList(edl,LISTITEM_INSTALLTOMBR);
  if (li)
  {
    AddItem(li);
  }

//  if (li)
//  li=new ListItem;
//  if (li)
//  {
//    // aufraeumen nicht vergessen!!!
//    EditList *edl=new EditList();
//    edl->AddCStr("Primre Partition auf der 1. Festplatte: [");
//    edl->AddVFlg(false);
//    edl->AddCStr("] (b)"); // fuer den cursor PaintItem() braucht mind. ein zeichen;
//    li->data=edl;
//    AddItem(li);
//  }

  edl=new EditList();
  if (edl)
  {
    // aufraeumen nicht vergessen!!!
    edl->AddCStr("Installation auf einer Diskette        : (");
    edl->AddVFlg(true);
    edl->AddCStr(") (b)"); // fuer den cursor PaintItem() braucht mind. ein zeichen;
  }
  li=new ListItemEditList(edl,LISTITEM_INSTALLTODISK);
  if (li)
  {
    AddItem(li);
  }

//  li=new ListItem;
//  if (li)
//  {
//    // aufraeumen nicht vergessen!!!
//    EditList *edl=new EditList();
//   edl->AddCStr("Genderte Sektoren speichern unter     :  ");
//    edl->AddVStr("a:\\sectors.bin                    ");
//    edl->AddCStr(" "); // fuer den cursor PaintItem() braucht mind. ein zeichen;
//    li->data=edl;
//    AddItem(li);
//  }

  SelectItem(0);
}

void InstallEdit::Paint()
{
  WindowEditListe::Paint();
}

void InstallEdit::SetCommand(char c)
{
  if (c==0x53)
    return; // entf
  WindowEditListe::SetCommand(c);
}

bool InstallEdit::InsertChar(char c)
{
  if (c==8)
    return false; // backspace akzeptieren wir nicht
  EditString *edl=GetSelectedEditString();
  if (*edl=="x")
    return false;
  if (!WindowEditListe::InsertChar(c))
    return false;
  int sel=GetSelectedItem();

  int count=0;
  FORALL(liste,ListItem)
  {
    selectItem=count;
    char *t=(char *)GetSelectedEditString()->Text();
    // alles ausser dem selektierten loeschen
    if (sel!=count)
    {
      t[0]=' ';
    }

    if (count==0)
      writeToMBR=*t=='x'?true:false;
    if (count==1)
      writeToDisk=*t=='x'?true:false;

    count ++;
  }
  selectItem=sel;
  Paint();
  return true;
}

/*const PartEntry *FindEntry(PartEntryList &peList,
                             const par_partitionentry &en)
{
  FORALL(peList,PartEntry)
  {
    const PartEntry &pe=it();
    // jetzt schauen wir mal was ein en zu bieten hat
    // im prinzip nur die anfangsadresse des bootsektors

    //byte  disk;
    //byte  lower8cyl;
    //byte  sek05cyl67;
    //byte  head;
    //dword lbaADR;
    zylsec s=en.lower8cyl;
    s=(s<<8)|en.sek05cyl67;

    if (en.disk  ==pe.hdnr &&
        s        ==pe.peBootSec.start_zyl &&
        en.head  ==pe.peBootSec.start_head &&
        en.lbaADR==pe.lbaADRpeBootSec)
      return &pe;

  }
  return NULL;
}
*/
//************************************************************                                         *
//*                                                          *
//* bootmanager_setparam()                                                   *
//*                                                          *
//************************************************************
void bootmanager_setparam(const PartEditWindow &pEdit,
                          const SelWindow      &sw,
                          const BootEditWindow &bEdit,
                          const PartEntryList  &peList)
{
  // main_boot_ends();
  // so- fertig --- jetzt wird der bootmanager
  // zusammengebaut
  int imax=pEdit.partEditList.GetItemCount();

  par_partitionentry *p=entries;
  for (int i_=0;i_<par_partition_entry_count;i_++)
  {
    memset(p,0,sizeof(par_partitionentry));
    p++;
  }

  p=entries;

  for (int i=0;i<imax;i++)
  {
    // (const ListItemSelWindow *)
    const ListItemSelWindow  & sel= sw[i];
    //const void* en=pEdit.partEditList[i];
    const EditList  & edl = sel.GetEditList();
    const PartEntry & pe  = sel.GetPartEntry();
    const PartitionEntry &pa = pe.PE();


    assert(edl[1].Len() ==sizeof(p->entryname));

    const char *p_name=edl[1].Text();
    p->isEntry=1;
    memcpy(p->entryname,p_name,32);
    AZString sizeMB=pe.GetSize();

    memset(p->addinfos,0x20,sizeof(p->addinfos));
    memcpy(p->addinfos+sizeof(p->addinfos)-sizeMB.Len(),
           sizeMB.Text(),sizeMB.Len());

    p->disk       = pe.hdnr;
    p->lower8cyl  = pa.start_zyl>>8;
    p->sek05cyl67 = pa.start_zyl;
    p->head       = pa.start_head;
    p->parameter  = atoi(edl[3].Text());
    p->lbaADR     = pe.lbaADRpeBootSec;

    // test, ob die lba-adresse auch stimmt
    /*Sector b;
    REGPACK    r;

    r.r_ax=0x4100;
    r.r_bx=0x55aa;
    r.r_dx=0x80;
    intr(0x13,&r);

    r.r_ax=0x4800;
    r.r_dx=0x80;
    b.code[0]=0x1a;
    b.code[1]=0;
    r.r_ds=FP_SEG(&b);
    r.r_si=FP_OFF(&b);
    intr(0x13,&r);

    struct long_ptr
    {
      word off;
      word seg;
    };

    struct     adrpack
    {
      byte  len;
      byte  reserved;
      word  blockCount;
      long_ptr transferbuffer;
      dword lbalow;
      dword lbahigh;
// 08h  QWORD   starting absolute block number
//              (for non-LBA devices, compute as
//                (Cylinder*NumHeads + SelectedHead) * SectorPerTrack +
//                SelectedSector - 1

    } a;

    r.r_ax=0x4200;
    r.r_dx=p->disk;
    a.len=0x10;
    a.reserved=0;
    a.blockCount=1;
    a.transferbuffer.seg=FP_SEG(&b);
    a.transferbuffer.off=FP_OFF(&b);
    r.r_ds=FP_SEG(&a);
    r.r_si=FP_OFF(&a);
    a.lbalow=pe.lbaADR;
    a.lbahigh=0;
    intr(0x13,&r);
    */
/*Return: CF clear if successful
            AH = 00h
        CF set on error
            AH = error code (see #00234)
            disk address packet's block count field set to number of blocks
              successfully transferred */

    // hiding_map zusammenbasteln
    // aus der hiding_map ist eine liste aller dos-partitionen
    // geworden. oder anders liste alle von einem moeglichen hiding
    // betroffene laufwerke
    const EditString & p_hiding=edl[INDEX_HIDING_MAP];
    char *dest=p->hiding_map;
    const char *src=p_hiding.Text();
    AZString alreadyInserted=" ";
    memset(p->hiding_map,0,sizeof(p->hiding_map));
    for (int i=0; i<p_hiding.Len(); i++,src++)
    {
      // <= heisst mit 0 byte kopieren
      char c=toupper(*src);
      if (strchr(alreadyInserted.Text(),c)==0)
      {
        *dest++=c;
        alreadyInserted+=c;
      }
    }

    const char *p_password=edl[5].Text();
    memset(p->password,0,sizeof(p->password));
    memcpy(p->password,p_password,edl[5].EditLen() );
    // wenn visible=0 nach eingabe des passworts
    // wird der eintrag sichtbar
    // edl9 ist hiding table
    p->flagfield  = 0; // visible    = (edl[11]=="x")?0:1;
    if (pe.GetDosName() && pe.prim==PRIM)
    {
      p->flagfield|=FLAG_SET_ACTIVE_FLAG;
    }
    p->flagfield|= sec_lookup[pe.par_type].flags;
    p++;
  }
  // hiding maps berechnen

  PartEntryList & pel=(PartEntryList &)peList;
  par_hidingmapentry far * pHideEntry=hide;


  // alle dos-paritionen merken
  FORALL(pel,PartEntry)
  {
    const PartEntry & pe=it;
    char  c=pe.GetDosName();
    if (c>='C' && c<='Z')
    {
      // falls die partition versteckt ist,
      // wird part_id = pe.PE().part_id & ~0x10 gesetzt
      // es wird also ohne versteckt-bit gespeichert
      HidingMapEntry m(c,pe.GetHdnr(),pe.GetIndexInTable(),
                     pe.Woher().start_zyl,pe.Woher().start_head,
                     pe.lbaADRpeWoher, pe.PE());
      // 1. eintrag
      *pHideEntry++=m.GetHidingMapEntry();
    }
  }
  //
  //par_startverzoegerung=0;
  par_wartezeit        =25;
//  par_beepbeimstart    =0; // 0==false



//  edlitem=bEdit.GetItemByID(LISTITEM_STARTVERZOEGERUNG);
//  if (edlitem)
//  {
//    par_startverzoegerung=atoi(edlitem->GetEditList()[INDEX_STARTVERZOEGERUNG]);
//  }

  const ListItemEditList *edlitem=bEdit.GetItemByID(LISTITEM_WARTEZEIT);
  if (edlitem)
  {
    par_wartezeit=max(1,atoi(edlitem->GetEditList()[INDEX_WARTEZEIT]));
  }

  edlitem=bEdit.GetItemByID(LISTITEM_UNBESCHRAENKT);
  if (edlitem)
  {
    bool unbeschraenkt=edlitem->GetEditList()[INDEX_UNBESCHRAENKT]=="x"?true:false;
    if (unbeschraenkt)
       par_wartezeit=0xffff;
  }

  edlitem=bEdit.GetItemByID(LISTITEM_MONO);
  if (edlitem)
  {
    bool isMono=edlitem->GetEditList()[INDEX_MONO]=="x"?true:false;
    if (isMono)
    {
      par_cols[0]=0x07; // COL_NORMAL
      par_cols[1]=0x0f; // COL_IMPORTANT
      par_cols[2]=0x07; // COL_MENU
      par_cols[3]=0x70; // COL_SEL
    } else
    {
      par_cols[0]=0x1f; // COL_NORMAL
      par_cols[1]=0x1e; // COL_IMPORTANT
      par_cols[2]=0x1f; // COL_MENU
      par_cols[3]=0x3e; // COL_SEL
    }
  }


/*
  edlitem=bEdit.GetItemByID(LISTITEM_BEEPBEIMSTART);
  if (edlitem)
  {
    par_beepbeimstart=edlitem->GetEditList()[INDEX_STARTVERZOEGERUNG]=="x"?1:0;
  }
*/
  if (licence.expiresno.type==EXPIRE_NO)
  {
    memcpy(register_text,"lizenziert fr: ",16);
    memcpy(register_name,licence.expiresno.name,sizeof(licence.expiresno.name));
  }
}

//************************************************************                                         *
//*                                                          *
//* main()                                                   *
//*                                                          *
//************************************************************

int main(int argc,char *argv[], char **env)
{
  MyArg myarg(argc,argv,env);
  if (myarg.monoColors.Get())
      cols=col_mono;

#ifdef DEBUG
  DebugTests();
#endif

  PartEntryList peList;
  FillPeList(peList);
  if (myarg.saveSectors.Get())
  {
    const char *t=myarg.saveSectors.GetChars();
    AZWriteFile wr(t);
    char buf[]="SECT10";
    wr.Write(buf,strlen(buf));

    if (wr.IsBad())
    {
      printf("Fehler: Kann Datei fr Partitionstabellen nicht ffnen! \"%s\"\n",t);
      exit(-1);
    }
    printf("Speichere alle Partitionstabellen ab. \"%s\"\n",t);

    AZDList <LbaREF> backRef; // wir speichern nur die sektoren an

    FORALL(peList,PartEntry)
    {
      const PartEntry & pe=it();
      if (pe.hdnr<0x80)
        continue; // fdd wird nicht abgespeichert
      LbaREF *r=new LbaREF();
      if (!r)
        printf("Warnung: kein freier Speicher(0001)\n");
      if (r)
      {
        r->hdnr   = pe.hdnr;
        r->lbaADR = pe.lbaADRpeWoher;
        FORALL(backRef,LbaREF)
        {
          const LbaREF *lbaref=&it();
          if (memcmp(r,lbaref,sizeof(lbaref))==0)
          {
            delete r;
            r=NULL;
          }
        }
        if (r)
          backRef.AddTail(r);
        else
          continue;
      }

      // nicht gefunden oder kein speicher
      // egal schreibe alles
      Sector s;

      byte  hdnr   = pe.hdnr;
      dword lbaADR = pe.lbaADRpeWoher;
      if (!BIOSLoadSectorLBA(hdnr, lbaADR, &s))
      {
        printf("Warnung: kann Sektor (hd:0x%02x)0x%08lx nicht lesen\n",hdnr-0x80,lbaADR);
      }
      else
      {
        printf("Speichere Sektor (hd:0x%02x)0x%08lx\n",hdnr-0x80,lbaADR);
        wr << it().hdnr;
        wr << it().lbaADRpeWoher;
        wr.Write(&s,sizeof(Sector));
        if (wr.IsBad())
        {
          printf("Warnung: Fehler beim Schreiben von \"%s\"\n",t);
        }
      }
    }
    exit(0);
  }
  //HeapClass <ImportSetting> imp;
  const ImportSetting imp;

  memcpy(version_str,VERSION_STR,sizeof(version_str));
  memcpy(boot_version,VERSION_STR,sizeof(boot_version));

  // grafik init starts
  BIOSSetMode(MODE_80x25_CO);
  mouse_init();
  _setcursortype(_NOCURSOR);
  byte textattrSaved=0x7;
  // grafik init ends

  bool goBack=false;

  TitelZeile t;t.Paint();
  FussZeile  f;f.Paint();
/*
  textattr(COL_TITLE);
  gotoxy(1,25);
  cprintf("\n");
  gotoxy(1,1);
  cprintf("Mr. Boot V"VERSION_STR" (c) 2000 HobiSoft           "
          "                                    ");
*/
  // schritt 1
  // liste der Partionseintraege
  PartitionWindow w(peList);
  // hilfetext
  HelpWindow      hw;
  // selektierte partitionseintraege
  SelWindow       sw(peList,imp);

  // schritt 2
  // partitionseintrage editieren
  PartEditWindow  pEdit; // rechts oben SelWindow

  // schritt 3
  BootEditWindow  bEdit(imp); // boot-parameter editieren
  BootSelWindow   bSel;  // liste der selektierten eintraege
                         // aber diesmal wird der eintrag fuers
                         // bootmenu angezeigt und die ID
  InstallHinweis  hinweis; // tips fuer die 3 moeglichen Alternativen
  InstallEdit     hinweisEdit; // liste der 3 alternativen

step1:

   w.Paint();
  hw.Paint();
  sw.Paint();

  hw.SetText("Schritt  1/4    "
             "    "
             "                "
             "Auswhlen der   "
             "Partitionen fr "
             "das Bootmenu");

  gotoxy(1,25);
/*  textattr(COL_KEY);
  cprintf("F1");
  textattr(COL_TITLE);
  cprintf("-Hilfe  ");
*/  textattr(COL_KEY);
  cprintf("");
  textattr(COL_TITLE);
  cprintf("-auswhlen  ");
  textattr(COL_KEY);
  cprintf("Entf");
  textattr(COL_TITLE);
  cprintf("-lschen  ");
  textattr(COL_KEY);
  cprintf("Enter");
  textattr(COL_TITLE);
  cprintf("-hinzufgen  ");
  textattr(COL_KEY);
  cprintf("F10");
  textattr(COL_TITLE);
  cprintf("-weiter  ");
  textattr(COL_KEY);
  cprintf("ESC");
  textattr(COL_TITLE);
  cprintf("-beenden");

  LicenceLoad();
  LicenceCheckDate();

  bool leave=false;
  while(!leave)
  {
    char c=getch();
    if (c==0)
    {
      c=getch();
      switch (c)
      {
        case 0x50: w.Down();   break;
        case 0x48: w.Up();     break;
        case 0x49:
        case 0x47: w.Top();    break;
        case 0x51:
        case 0x4f: w.Bottom(); break;
        case 0x53: sw.Delete(); break;
        case 0x44:
          // f10
          if (sw.ListNotEmpty())
            leave=true;
          else BIOSBeep();
        default:
          break;
      }
      c=0;
    }
    if (c==0x0d)
    {
      sw.Insert(w.GetSelectedItem());
      sw.Paint();
    }
//    printf("_%x_",c);
    if (c==0x1b)
    {
      textattr(textattrSaved);
      BIOSRestoreMode();
      clrscr();
      return 0;
    }
  }


step2:

  pEdit.Init(sw,w.GetPartEntryList());
  sw.Paint();

  leave=false;
  hw.SetText("Schritt  2/4    "
             "    "
             "                "
             "Einstellungen   "
             "der Parameter   "
             "fr die einzel- "
             "nen Eintrge");


  gotoxy(1,25);
/*  textattr(COL_KEY);
  cprintf("F1");
  textattr(COL_TITLE);
  cprintf("-Hilfe  ");
*/  textattr(COL_KEY);
  cprintf("-Tab-Shift+Tab");
  textattr(COL_TITLE);
  cprintf("-auswhlen  ");
  textattr(COL_KEY);
  cprintf("F9");
  textattr(COL_TITLE);
  cprintf("-zurck  ");
  textattr(COL_KEY);
  cprintf("F10");
  textattr(COL_TITLE);
  cprintf("-weiter  ");
  textattr(COL_KEY);
  cprintf("ESC");
  textattr(COL_TITLE);
  cprintf("-beenden       ");

  pEdit.Paint();

  while(!leave)
  {
    char c=getch();
    if (c==0)
    {
      c=getch();
      switch (c)
      {
        case 0x50:
        case 0x53:
        case 0x48:
        case 0x49:
        case 0x47:
        case 0x51:
        case 0x4f:
        case 0x4d:
        case 0x4b:
        case 0x0f: pEdit.SetCommand(c); break;
        case 0x43: goBack=true;leave=true; break;
        case 0x44: leave=true;       break;
        default:
          //printf("ext char _%02x_",c);
          //BIOSBeep();
          break;
      }
    } else
    {
      switch (c)
      {
        case 0x9:
        case 0x0d:
          pEdit.SetCommand(c);      break;
        case 0x1b:
          textattr(textattrSaved);
          BIOSRestoreMode();
          clrscr();
          return 0;
        default:
          pEdit.InsertChar(c);
      }
    }
  }
  if (goBack)
  {
    goBack=false;
    goto step1;
  }
step3:

  leave=false;
  hw.SetText("Schritt  3/4    "
             "    "
             "                "
             "Einstellungen   "
             "der Parameter   "
             "fr den Boot-   "
             "manager        ");

  gotoxy(1,25);
/*  textattr(COL_KEY);
  cprintf("F1");
  textattr(COL_TITLE);
  cprintf("-Hilfe  ");
*/  textattr(COL_KEY);
  cprintf("-Tab-Shift+Tab");
  textattr(COL_TITLE);
  cprintf("-auswhlen  ");
  textattr(COL_KEY);
  cprintf("F9");
  textattr(COL_TITLE);
  cprintf("-zurck  ");
  textattr(COL_KEY);
  cprintf("F10");
  textattr(COL_TITLE);
  cprintf("-weiter  ");
  textattr(COL_KEY);
  cprintf("ESC");
  textattr(COL_TITLE);
  cprintf("-beenden       ");

  bEdit.Init();
  bEdit.Paint();

  bSel.Init(&pEdit);

  while(!leave)
  {
    char c=getch();
    if (c==0)
    {
      c=getch();
      switch (c)
      {
        case 0x50:
        case 0x53:
        case 0x48:
        case 0x49:
        case 0x47:
        case 0x51:
        case 0x4f:
        case 0x4d:
        case 0x4b:
        case 0x0f: bEdit.SetCommand(c);    break;
        case 0x43: goBack=true;leave=true; break;
        case 0x44: leave=true;             break;
        default:
          //printf("ext char _%02x_",c);
          //BIOSBeep();
          break;
      }
    } else
    {
      switch (c)
      {
        case 0x9:
        case 0x0d:
          bEdit.SetCommand(9);      break;
        case 0x1b:
          textattr(textattrSaved);
          clrscr();
          BIOSRestoreMode();
          return 0;
        default:
          bEdit.InsertChar(c);
      }
    }
  }
  if (goBack)
  {
    goBack=false;
    goto step2;
  }

  hinweis.Paint();
  hinweisEdit.Paint();

  hw.SetText("Schritt  4/4    "
             "    "
             "                "
             "Bootmanager     "
             "installieren... "
             "                "
             "               ");

  gotoxy(1,25);
/*  textattr(COL_KEY);
  cprintf("F1");
  textattr(COL_TITLE);
  cprintf("-Hilfe  ");
*/  textattr(COL_KEY);
  cprintf("F8");
  textattr(COL_TITLE);
  cprintf("-testen  ");
  textattr(COL_KEY);
  cprintf("F9");
  textattr(COL_TITLE);
  cprintf("-zurck  ");
  textattr(COL_KEY);
  cprintf("Shift-F10");
  textattr(COL_TITLE);
  cprintf("-installieren  ");
  textattr(COL_KEY);
  cprintf("ESC");
  textattr(COL_TITLE);
  cprintf("-beenden            ");

step4:
#ifdef DEBUG
  //heap_check();
  //heap_free_count();
#endif

  leave=false;
  while(!leave)
  {
    char c=getch();
    if (c==0)
    {
      c=getch();
      switch (c)
      {
        case 0x50:
        case 0x53:
        case 0x48:
        case 0x49:
        case 0x47:
        case 0x51:
        case 0x4f:
        case 0x4d:
        case 0x4b:
        case 0x0f: hinweisEdit.SetCommand(c);    break;
        case 0x42:
          if (!LicenceCheckDate())
            goto step4;
          bootmanager_setparam(pEdit,sw,bEdit,w.GetPartEntryList());
          // starts bootmanager in testmode
          // dont boots
          par_test_mode=1;
          if (hinweisEdit.writeToDisk)
            par_config|=CFG_NO_WRITE;

          //par_test_mode=0;
          // switch to page 1 , so nothing has to be repaint
          // geht auf herkules nicht immer
          BIOSSaveScreen();
          main_boot();
          BIOSRestoreScreen();

          // and back to page 0
          break;

        case 0x43: goBack=true;leave=true; break;
        case 0x5d: leave=true;             break; // shift+F10
        default:
          //printf("ext char _%02x_",c);
          //BIOSBeep();
          break;
      }
    } else
    {
      switch (c)
      {
        case 0x9:
        case 0x0d:
          hinweisEdit.SetCommand(9);      break;
        case 0x1b:
          textattr(textattrSaved);
          clrscr();
          BIOSRestoreMode();
          return 0;
        default:
          hinweisEdit.InsertChar(c);
      }
    }
  }
  if (goBack)
  {
    goBack=false;
    goto step3;
  }
  // nun schreiben
  if (!LicenceCheckDate())
    goto step4;

  if (!hinweisEdit.writeToDisk && !hinweisEdit.writeToMBR)
    goto step4;

  int hdnr=0x80;
  boot_disk=0x80;

  if (hinweisEdit.writeToDisk)
  {
    hdnr=0;
    boot_disk=0;
    par_config|=CFG_NO_WRITE;
  }

  Sector mbr;
  gotoxy(3,17);
  textattr(0x1f);
  //if (!BIOSGetSector(0x80,0,0x0001,&mbr))

  if (!BIOSLoadSectorLBA(0x80,0,&mbr))
  {
    cprintf("!!! kann MBR von Platte:0 nicht lesen !!!\n");
    goto step4;
  }
  cprintf("MBR von Platte:0 eingelesen");
  char far *boot_start=(char far *)bootsec_start;
  char far *boot_end=  (char far *)bootsec_ends;


  word boot_sec_len=(word)(boot_end-boot_start);
  int _sectorLen=((par_byte_len-1)/512)+1;
  assert(_sectorLen<17); // max 16 sektoren ab sektor 1

  boot_seccount=min(_sectorLen,16);

  assert((boot_sec_len)<=0x1b0);


  int min_size=min((int)boot_sec_len,(int)0x1b0);
  memcpy(&mbr,boot_start,min_size);

  gotoxy(3,18);

  par_test_mode=0;  // keine test mode des bootmanagers
  bootmanager_setparam(pEdit,sw,bEdit,w.GetPartEntryList());

  if (_sectorLen<17 && BIOSWriteBootMgrToHead0(hdnr,(char *)main_boot,par_byte_len))
  {
    cprintf("Bootmanager erfolgreich in Spur 0 der %s geschrieben\n",
           hdnr==0?"Diskette":"Platte:0");
  }
  else
  {
    cprintf("Bootmanager nicht erfolgreich in Spur 0 der %s geschrieben\n",
           hdnr==0?"Diskette":"Platte:0");
    goto step4;
  }

  gotoxy(3,19);
  if (_sectorLen<17 && boot_sec_len<=0x1b0 && BIOSWriteMBR(hdnr,&mbr))
  {
    cprintf("MBR erfolgreich auf %s geschrieben\n",
            hdnr==0?"Diskette":"Platte:0");
  }
  else
  {
    cprintf("MBR nicht erfolgreich auf %s geschrieben\n",
            hdnr==0?"Diskette":"Platte:0");
    goto step4;
  }
  goto step4;
}


