// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial use without permit.                                *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************
#include <baselib/all.h>

#include <conio.h>
#include <dos.h>

#include "biosdefs.h"
#include "asmdefs.h"
#include "impsett.h"
#include "mouse.h"

#include "partentry.h"
//#include "debug.h"
#include "version.h"
#include "myargs.h"
#include "mywin.h"
#include "licence.h"

_WindowListe_::_WindowListe_(int _x,int _y,int _w,int _h, int _style)
:Window(_x,_y,_w,_h) // ohne rand
,listCount(0)
,topItem(0)
,listVisible(h)
,selectItem(-1)
,style(_style)
{
}

void _WindowListe_::AddItem(ListItemBase *it)
{
  assert(it);
  if (!it)
    return;
  liste.AddTail(it);
  listCount++;
  // biite nicht den style aendern
  // lieber die abfrage nach Paint()
  //if (listCount>listVisible)
  //  style&=~LB_NOVSCROLLBAR;
}

void _WindowListe_::SelectItem(int count)
{
  if (count==-1)
  {
    selectItem=count;
    return;
  }
  if (count>=listCount)
  {
    return;
  }
  // wenn selected item nicht mehr sichtbar ist
  if (count!=-1)
  {
    if (count<topItem || count>=topItem+listVisible)
    {
      // aber bitte nur soweit wie auch noch elemente da sind
      topItem=min(max(0,topItem+count-selectItem),
                  max(0,listCount-listVisible) );

    }
  }
  //
  selectItem=count;
}


ListItemBase *_WindowListe_::GetItem()
{
  int count=0;
  if (selectItem==-1)
    return NULL;

  FORALL(liste,ListItemBase)
  {
    if (count==selectItem)
      return &it();
    count++;
  }
  return NULL;
}

void _WindowListe_::RemoveItem(int _count)
{
  int count=0;

  FORALL(liste,ListItemBase)
  {
    if (count==_count)
    {
      if (count==selectItem)
        selectItem=-1;
      listCount--;
      it.Remove();
      return; // bitte!!! als naechstes macht FORALL
              // ein it++ und der geht schief wenn it==0 ist
    }
    count++;
  }
}

void _WindowListe_::PaintItem(const ListItemBase &it,bool selected)
{
  if (selected)
      textattr(COL_SELECT);
    cprintf("%s",it.Text());
  if (selected)
      textattr(COL_NORMAL);
}

void _WindowListe_::Paint()
{
  int myy=y+2;// +1 fuer titel zeile +1 fuer 1-basiert
  int myx=x+w;

  if ((style&LB_NOVSCROLLBAR)==0 && listCount>listVisible)
  {
    ::gotoxy(myx,myy);
    textattr(COL_BW);
    putch('');
    textattr(COL_NORMAL);
    myy++;

    // i=2; heisst: 2 zeichen=oben+unten weglassen fuer pfeile
    for (int i=2;i<h;i++,myy++)
    {
      ::gotoxy(myx,myy);
      putch('');
    }
    textattr(COL_BW);
    ::gotoxy(myx,myy);
    putch('');
  }
  else
  {
    textattr(COL_NORMAL);
    for (int i=1;i<=h;i++,myy++)
    {
      ::gotoxy(myx,myy);
      putch(RIGHT);
    }
  }

  textattr(COL_NORMAL);
  myy=y+2;
  myx=x+1;
  ::gotoxy(myx,myy);
  int curItem=0;
  FORALL(liste,ListItemBase)
  {
    if (curItem>=topItem+listVisible)
      break;
    if (curItem<topItem)
    {
      curItem++;
      continue;
    }
    ::gotoxy(myx,myy);

    PaintItem(it(),(curItem==selectItem)?true:false);
    curItem++;
    myy++;
  }
  // mal schauen ob auch leere zeilen in der liste sind
  for (;curItem<topItem+listVisible;curItem++,myy++)
  {
    ::gotoxy(myx,myy);
    for (int i=1; i<w;i++) putch(SPACE);
  }
}

void *_WindowListe_::GetItemByID(int id)
{
  int count=0;

  FORALL(liste,ListItemBase)
  {
    const ListItemBase &item=it;
    if (item.GetID()==id)
    {
      return &it();
    }
    count++;
  }
  return 0;
}

const void *_WindowListe_::GetItemByID(int id) const
{
  int count=0;

  ListItemBaseDList &el=(ListItemBaseDList &) liste;

  FORALL(el,ListItemBase)
  {
    const ListItemBase &item=it;
    if (item.GetID()==id)
    {
      return &it();
    }
    count++;
  }
  return 0;
}

const ListItemBase *_WindowListe_::GetItem() const
{
  int count=0;
  if (selectItem==-1)
    return NULL;

  ListItemBaseDList &el=(ListItemBaseDList &) liste;
  FORALL(el,ListItemBase)
  {
    if (count==selectItem)
      return &it();
    count++;
  }
  return NULL;
}

/*
EditString::EditString(const char *t,bool c,bool _move,const char *filter)
:AZString(t)
,isConst(c)
,cursor(0)
,editLen(0)
,moveCursor(_move)
,filter_str(filter)
{
  if (isConst || !moveCursor)
    return;
  cursor=strlen(t);
  const char *endPtr=t+strlen(t)-1;
  while(endPtr>=t && *endPtr==' ')
  {
    endPtr--;
    cursor--;
  }
  if (cursor)
    editLen=cursor;
}

bool  EditString::SetChar(char c)
{
  if (cursor==Len())
    return false;
  if (filter_str.Len() && strchr(filter_str,c)==NULL)
    return false;
  char *p=(char *)Text();
  p[cursor]=c;
  return true;
}

void EditList::AddVStr(const char *t,const char *filter_str)
{
  EditString *e=new EditString(t,false,true,filter_str);
  AddTail(e);
}
bool WindowEditListe::InsertChar(char c)
{
  int numEntry=0;
  int count   =0;

  FORALL(liste,ListItem)
  {
    if (selectItem==numEntry)
    {
      EditList &edl=*(EditList*)it().Data();
      FORALL(edl,EditString)
      {
        if (!it().IsConst() )
        {
          if (h_selected==count)
          {
            EditString &str=it;

            switch (c)
            {
              case 8:
              {
                int cr      = str.GetCursor();
                int len     = str.Len();
                int editLen = str.EditLen();
                if (!str.MoveCursor() && str.Len())
                {
                  str.SetChar(0x20);
                }
                if (cr>0)
                {
                  str.SetCursor(--cr);
                  str.SetChar(0x20);
                  len--; // len ist jetzt index des letzten zeichens
                  str.SetEditLen(--editLen);
                  if (cr<len)
                  {
                    char *p=(char *)str.Text();
                    memmove(p+cr,p+cr+1,len-cr);
                    p[len]=' ';
                  }
                }
                Paint();
                break;
              }
              case 7:    // bell
              case 9:    // hoch
              case 10:   // runter
              case 13:   // enter
              case 27:   // esc
                return false;
              default :
              {
                int cr  = str.GetCursor();
                int len = str.Len();
                if (cr>=len)
                {
                  return false;
                }

                bool ret=str.SetChar(c);
                if (!ret)
                {
                  return false;
                }
                //if ret && str.Move...
                if (str.MoveCursor())
                {
                  str.SetCursor(++cr);
                  if (c!=0x20)
                  {
                    int editLen=str.EditLen();
                    str.SetEditLen(max(editLen,cr));
                  }
                }
                Paint();
                return true;
              }
            }
          }
          count++;
        }
      }
    }
    numEntry++;
  }
  return false;
}

bool EditIntString::SetChar(char c)
{
  if ( (c<'0' || c>'9') && c!=0x20)
    return false;
  return EditString::SetChar(c);
}

void WindowEditListe::PaintItem(const ListItemBase &__it,bool selected)
{
  ListItem &_it=(ListItem &)__it;

  EditList &edl=*(EditList*)_it.Data();
  int numEntry=0;
  bool cursorExeeds=false; // cursor steht 1 hinter dem letzten feld

  char filter[]="\x7\x9\xa\xd\27";

  FORALL(edl,EditString)
  {
    EditString &es=it;

    bool _selected=selected && (numEntry==h_selected) && !es.IsConst();
    const char *t=es.Text();
    int i=0;

                        // falls jemand AZString("") anhaengt!
    if (cursorExeeds && es.Len())
    {
      textattr(COL_CUR);
      putch(*t);
      t++;
      i++;
      cursorExeeds=false;
      textattr(COL_NORMAL);
    }
    if (_selected)
      textattr(COL_SELECT);

    if (!es.IsConst() && !_selected )
      textattr(COL_EDIT);

    for (; i<es.Len();i++,t++)
    {
      if (_selected && i==es.GetCursor())
        textattr(COL_CUR);
      char c=*t;
      if (strchr(filter,c))
        c='.';
      putch(c);
      if (_selected && i==es.GetCursor())
        textattr(COL_SELECT);
    }

    if (!es.IsConst() )
      textattr(COL_NORMAL);


    if (_selected && es.GetCursor()==es.Len())
    {
      cursorExeeds=true;
    }

    if (_selected)
      textattr(COL_NORMAL);
    if (!es.IsConst())
      numEntry++;
  }
}


const EditString & EditList::operator[](int index) const
{
  int count=0;
  EditList &el=(EditList &) *this;

  FORALL(el,EditString)
  {
  #ifdef DEBUG
    const EditString & es=it;
    es.Text(); // warning soll weg
  #endif
    if (count==index)
      return it;
    count ++;
  }
  return *(EditString*)First()->Data();
}
*/
